/*	main.c - Unit Test for Contact
 *
 *	Authors: YE Nan <nan.ye@orange-ftgroup.com>
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */
#include <stdio.h>
#include <string.h>
#include <CUnit/Basic.h>
#include <CUnit/Basic.h>

#include "test-exchange.h"

int
main (int		 argc,
			char	*argv[])
{
  CU_pSuite pSuite_test_exchange = NULL;

	if (CUE_SUCCESS != CU_initialize_registry())
	{
		return CU_get_error();
	}
	
  pSuite_test_exchange = CU_add_suite("test_exchange",
  																		init_suite_exchange,
  																		clean_suite_exchange);
  if (NULL == pSuite_test_exchange)
  {
		CU_cleanup_registry ();
		
		return CU_get_error ();
  }

 	/*
	 * add tests for exchange service:
	 * store, "application/x-vcard"
	 */
/*  if (NULL == CU_add_test(pSuite_test_exchange,
  												"test exchange service: store, application/x-vCard",
  												testEXCHANGE_STORE_VCARD))
  {
    CU_cleanup_registry ();
    return CU_get_error ();
  }
*/
 	/*
	 * add tests for exchange service:
	 * get, "application/x-contact"
	 */
  if (NULL == CU_add_test(pSuite_test_exchange,
  												"test exchange service: get, application/x-contact",
  												testEXCHANGE_GET_CONTACT))
  {
    CU_cleanup_registry ();
    return CU_get_error ();
  }

	CU_basic_set_mode(CU_BRM_VERBOSE);
	CU_basic_run_tests();
	CU_cleanup_registry();
	
	return CU_get_error();
}

/*
vi:ts=2:nowrap:ai:expandtab 
*/
