dnl
dnl AM_PATH_CUNIT
dnl

AC_DEFUN(AM_PATH_CUNIT,
[

AC_ARG_ENABLE(test,
              [AC_HELP_STRING([--enable-test],
              [build unit tests with CUnit [default=no]])],,
              [enable_test="no"])
AC_ARG_WITH(cuint,
						[AC_HELP_STRING([--with-cuint=PATH],
						[specify location of CUnit directory])])

if test "x$with_cunit" = "x" ; then
  CUNIT_CFLAGS=""
  CUNIT_LIBS="-lcunit -lncurses"
else
  CUNIT_CFLAGS="-I$with_cunit/include"
  CUNIT_LIBS="-L$with_cunit/lib -lcunit -lncurses"
fi
AC_SUBST(CUNIT_CFLAGS)
AC_SUBST(CUNIT_LIBS)

if test x$enable_test = xyes ; then
  saved_CPPFLAGS="$CPPFLAGS"
  saved_LIBS="$LIBS"
  CPPFLAGS="$CPPFLAGS $CUNIT_CFLAGS"
  LIBS="$LIBS $CUNIT_LIBS"

  AC_CHECK_LIB(cunit, CU_basic_run_tests,,enable_test=no)
  AC_CHECK_HEADER([CUnit/CUnit.h],,enable_test=no)

  CPPFLAGS=$saved_CPPFLAGS
  LIBS=$saved_LIBS
fi

AM_CONDITIONAL(BUILD_CUNIT_TEST,
               test x$enable_test = xyes)

])

