/*	contact - LiPS Address Book Application
 *
 *	Authors: YE Nan <nan.ye@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef __AB_APP_ENABLER_H
#define __AB_APP_ENABLER_H

#include <glib.h>

#include <addressbook.h>
#include <uicompcnteditview.h>
#include <uicompcntlistview.h>
#include <uicompcntlstview.h>
#include <uicompinitview.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


typedef enum
  {
  	AB_IV_UID = 1,
  	AB_IV_CATEGORY_ID,
		AB_IV_FULL_NAME,
  	AB_IV_LAST_NAME,
  	AB_IV_MIDDLE_NAME,
  	AB_IV_FIRST_NAME,
  	AB_IV_MOBILE_NUM,
  	AB_IV_HOME_NUM,
  	AB_IV_BUSINESS_NUM,
	  AB_IV_FAX_NUM,
	  AB_IV_COMPANY,
  	AB_IV_DEPARTMENT,
  	AB_IV_WEBSITE,
  	AB_IV_EMAIL,
  	AB_IV_PICTURE,
  	AB_IV_RINGTONE,
  	AB_IV_HOME_STREET,
  	AB_IV_HOME_CITY,
  	AB_IV_HOME_STATE,
  	AB_IV_HOME_ZIP,
  	AB_IV_HOME_COUNTRY,
  	AB_IV_BUSI_STREET,
  	AB_IV_BUSI_CITY,
  	AB_IV_BUSI_STATE,
  	AB_IV_BUSI_ZIP,
  	AB_IV_BUSI_COUNTRY,
  	AB_IV_NUM,
  } CntItemID;
  

typedef enum
{
  CAT_UID = 1,
  CAT_NAME,
  CAT_PICTURE,
  CAT_RINGTONE,
  NUM_CATS
} CategoryItemID;

typedef enum
{
	FIELD_MUL,
	FIELD_NONE,
	FIELD_EXTEND,
	NUM_FIELD_TYPE,
}FieldType;

#define CNT_SIM_INDEX	100

enum {
	STORAGE_LOCAL,
	STORAGE_SIM,
	STORAGE_NET,
	STORAGE_NON,
};

typedef enum {
	SESSION_LOCAL,
	SESSION_SIM,
	SESSION_NET,
	NUM_SESSIONS,
} ABSessionEnum;

gboolean	ab_enabler_initialize 	(void);
void			ab_enabler_finalize			(void);

ab_sid_t	ab_enabler_get_session	(ABSessionEnum sess);

#define	AB_ENABLER_SESS_LOCAL	ab_enabler_get_session(SESSION_LOCAL)
#define	AB_ENABLER_SESS_SIM		ab_enabler_get_session(SESSION_SIM)
#define	AB_ENABLER_SESS_NET		ab_enabler_get_session(SESSION_NET)

gboolean		ab_enabler_ui_comp_list_view_find			(GemTreeView		*cntview,
																											 ab_uid_t							 uidcomp,
																											 GtkTreeIter					*iter);
void				ab_enabler_ui_comp_list_view_delete (GemTreeView			*cntview,
																										 const ab_uid_t *uid);																											 
void				ab_enabler_ui_comp_cnt_list_view_add			(UICompCntListView		*cntview,
																											 const ab_contact_t		*contact);
void				ab_enabler_ui_comp_cnt_list_view_update		(UICompCntListView		*cntview,
																											 const ab_contact_t		*contact,
																											 GtkTreeIter					*iter);

GThread *		ab_enabler_start_thread										(GThreadFunc					 func,
																											 gpointer							 user_data);

gpointer		ab_enabler_cnt_list_view_load_contacts_thread (gpointer arg);
//gpointer 		ab_enabler_cnt_list_view_load_contacts_thread (GemNotification *notifier);

gpointer		ab_enabler_cnt_list_view_load_sim_contacts_thread (UICompCntListView *cntview,GemNotification *notifier);

void				ab_enabler_ui_comp_cnt_list_view_add_sim	(UICompCntListView		*cntview,
																											 const ab_contact_t		*contact);
void				ab_enabler_ui_comp_cnt_list_view_update_sim	(UICompCntListView		*cntview,
																											 	const ab_contact_t		*contact,
																											 	GtkTreeIter					*iter);

void				ab_enabler_cnt_parse_from_edit_view (GemHashView *view,ab_contact_t **contact);
void				ab_enabler_cnt_parse_from_edit_view_sim (GemHashView *view,ab_contact_t **contact);
void				ab_enabler_cnt_edit_view_set_contact 		(UICompCntEditView 		*cntview,
																										 ab_contact_t					*contact);

gpointer		ab_enabler_cat_list_view_load_category_thread(gpointer arg);
void				ab_enabler_ui_comp_cat_list_view_add (UICompCntListView			*cntview,
																									const ab_category_t		*category);
void				ab_enabler_ui_comp_cat_list_view_update (UICompCntListView		*cntview,
																										 const ab_category_t	*category,
																										 GtkTreeIter					*iter);																							

void 				ab_enabler_ui_comp_main_window(UICompInitView *mainview);


/********************************************
 * Update Version of Contact List View
 */
void					ab_enabler_ui_comp_cnt_lst_view_add				(UICompCntLstView					*cntlview,
																												 const ab_contact_t				*contact,
																												 gint											 storage);
void					ab_enabler_ui_comp_cnt_lst_view_update		(UICompCntLstView					*cntlview,
																												 const ab_contact_t				*contact,
																												 gint											 storage,
																												 GtkTreeIter							*iter);
void					ab_enabler_ui_comp_cnt_lst_view_remove		(UICompCntLstView					*cntlview,
																												 const ab_uid_t				 		*uid);
gboolean			ab_enabler_ui_comp_cnt_lst_view_find			(UICompCntLstView					*cntlview,
																												 ab_uid_t									 uidcomp,
																												 GtkTreeIter							*iter);

gpointer			ab_enabler_cnt_lst_view_load_contacts			(gpointer									 arg);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __AB_APP_ENABLER_H */

/*
vi:ts=2:nowrap:ai:expandtab
*/
