/*	contact - LiPS Address Book Application
 *
 *	Authors: YE Nan <nan.ye@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#include <stdio.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gem.h>
#include <abtypes.h>
#include <abcontact.h>
#include <gemhashview.h>
#include <gemhashviewcellimg.h>
#include <uicompskwindow.h>
#include <uicompwinmgr.h>
#include "enabler.h"

#include <uicompcntlistview.h>
#include <uicompcnteditviewsim.h>

static void ui_comp_cnt_list_view_class_init		(UICompCntListViewClass	*klass);
static void ui_comp_cnt_list_view_init					(UICompCntListView			*cntview);
static void	ui_comp_cnt_list_view_destroy				(GtkObject							*object);
void ui_comp_cnt_list_view_update (UICompCntListView	*cntview);

static GemTreeViewClass * parent_class = NULL;

typedef struct _UICompCntListViewPriv UICompCntListViewPriv;

struct _UICompCntListViewPriv
{
	GHashTable *cntlist_hash;
};
#define UI_COMP_CNT_LIST_VIEW_GET_PRIVATE(obj)(G_TYPE_INSTANCE_GET_PRIVATE((obj), \
																							 UI_COMP_TYPE_CNT_LIST_VIEW, \
																							 UICompCntListViewPriv));

static void 
cnt_list_view_softkey_activated_cb (GpeSKWindow *window,
                                    gint nr,
                                    GemHashView  *view)
{
  gboolean ret = FALSE;	
  if (nr == UI_COMP_SK_LEFT)
  {
    g_print ("%s(): Left Softkey\n", __FUNCTION__);    
  }
  else if (nr == UI_COMP_SK_RIGHT)
  {
    g_print ("%s(): Right Softkey\n", __FUNCTION__);
    if (view)
    {
      view->status = GEM_HV_STATUS_CANCEL;
    }
    ret = TRUE;
  }
  if (ret)
  {
    gtk_widget_hide_all (GTK_WIDGET (window));
  }	
	return;	
}

void
mw_cnt_list_view_row_cb(gchar *uid) 
{
//	g_print("%s(): uidstr = %d entering ......\n",__FUNCTION__,uidstr);
	ab_contact_t *contact = NULL;
//	ab_uid_t uid = AB_ID_INVALID;
  ab_get_contact(ab_enabler_get_session(0), (ab_uid_t)uid, &contact);
  ab_contact_print(contact);
  if (TRUE)
  {
    GtkWidget *cntlistview = NULL;
    GtkWidget *sub_window = NULL;
    GtkWidget *app = NULL;
		GtkWidget *cell = NULL;
		GdkPixbuf *pixbuf = NULL;
		gchar *picpath = NULL;
		
		ab_fid_t *fid = NULL;
    gint i = 0;
    ab_ftid_t ftid = 0;
    
    cntlistview = ui_comp_cnt_edit_view_new(NULL);
         
    ab_contact_print(contact);
		ab_contact_list_fields(contact,&fid);  
		
		for (i = 0; fid[i] != NULL; i++)
		{
	    gchar *fieldstr = NULL;
	    
			ab_contact_get_ftid(contact,fid[i],&ftid);
			if(ftid==AB_IV_UID)
			{
				gint uid;
				ab_contact_get_int32_field(contact, fid[i], &uid);
    		fieldstr = g_strdup_printf("%d",uid);
			}
			else
			{
				ab_contact_get_string_field(contact, fid[i], &fieldstr);
			}
//			g_print("%s(): %d, (%d, %d)--------------------fieldstr(%s)----------------\n",
//							__FUNCTION__,
//							i,
//							fid[i],
//							ftid,
//							(fieldstr ? fieldstr : "(null)"));
				if(fieldstr	!= NULL)
				{
					gem_hash_view_set_value(GEM_HASH_VIEW(cntlistview),
														      ftid,
														      fieldstr);
				}			
				g_free(fieldstr);
		}     
		
		ab_category_t **categories = NULL;
		gchar *cat_content = g_new0(gchar,50);
		ab_get_categories_for_contact(ab_enabler_get_session(0),
																	(ab_uid_t)uid,
																	&categories);
		gint j = 0;	
		char *cat_name = "";																		
		for (j = 0; categories[j] != NULL; j++)					
		{
    	ab_category_get_name (categories[j], &cat_name);
    	g_print("%s(): LINE(%d) cat_content (%s)  cat_name(%s)\n",__FUNCTION__,__LINE__,cat_content,cat_name);		
			if(categories[j+1] != NULL)
			{
				cat_content = g_strconcat(cat_content,cat_name,", ",NULL);
			}
			else
				cat_content = g_strconcat(cat_content,cat_name,NULL);
		}							
									
		gem_hash_view_set_value(GEM_HASH_VIEW(cntlistview),
											      AB_IV_CATEGORY_ID,
											      cat_content);
 
 		g_free(cat_name);
		   
		GEM_HASH_VIEW(cntlistview)->focused_item = AB_IV_BUSINESS_NUM;		
													     	 
		gem_hash_view_set_editable(GEM_HASH_VIEW(cntlistview),FALSE);
		
    sub_window = ui_comp_skwindow_new(cntlistview,
																"",
																"Back",															
																"",
																NULL,
																0,
																NULL);
  	g_signal_connect(G_OBJECT(sub_window),
									   "softkey_activated",
									    G_CALLBACK(cnt_list_view_softkey_activated_cb),
								    	GEM_HASH_VIEW(cntlistview));
							    	
		ab_contact_free (contact);				    	

		gtk_widget_show_all(sub_window);	
  }
  return;	
}

void
mw_cnt_list_view_sim_row_cb(gchar *uid) 
{
	ab_contact_t *contact = NULL;
	g_print("%s() : uid = %d   ............        \n",__FUNCTION__,uid);
  ab_get_contact(ab_enabler_get_session(1), (ab_uid_t)uid, &contact);
  ab_contact_print(contact);
  if (TRUE)
  {
    GtkWidget *cntlistview = NULL;
    GtkWidget *sub_window = NULL;
    GtkWidget *app = NULL;
		GtkWidget *cell = NULL;
		GdkPixbuf *pixbuf = NULL;
		gchar *picpath = NULL;
		
    cntlistview = ui_comp_cnt_edit_view_sim_new(); 
  
    //set contact's name
    gchar *fieldstr = NULL;
    ab_contact_get_full_name	(contact, &fieldstr);
    g_print("%s() : ( %s )fieldstr = %d \n",fieldstr,fieldstr);
    if(fieldstr != NULL)
    {
    	gem_hash_view_set_value (GEM_HASH_VIEW(cntlistview),
													      AB_IV_FULL_NAME,
													      fieldstr);
    }														      										      
    //set contact's mobile phone
    ab_contact_get_mobile_num	(contact, &fieldstr);
    if(fieldstr != NULL)
    {
    	gem_hash_view_set_value (GEM_HASH_VIEW(cntlistview),
													      AB_IV_MOBILE_NUM,
													      fieldstr);
    }		
		//set UID		
		gchar *tmpuid = NULL;
  	tmpuid = g_new0(gchar, 6);
    g_sprintf (tmpuid, "%d",uid);        
    g_print("%s() : uid = %d   \n",__FUNCTION__,uid);
    g_print("%s() : tmpuid = %s   \n",__FUNCTION__,tmpuid); 
    if(tmpuid != NULL)
    {   
    	gem_hash_view_set_value (GEM_HASH_VIEW(cntlistview),
												     	 AB_IV_UID*1000,
												     	 tmpuid);
    }	
		gem_hash_view_set_editable(GEM_HASH_VIEW(cntlistview),FALSE);		
    sub_window = ui_comp_skwindow_new(cntlistview,
																"",
																"Back",															
																"",
																NULL,
																0,
																NULL);
  	g_signal_connect(G_OBJECT(sub_window),
									   "softkey_activated",
									    G_CALLBACK(cnt_list_view_softkey_activated_cb),
								    	GEM_HASH_VIEW(cntlistview));
	
		gtk_widget_show_all(sub_window);
  }

  ab_contact_free (contact);

  return;
	
}

static void 
ui_comp_cnt_list_view_row_activated(GtkTreeView *treeview, GtkTreePath *path,
                          			    GtkTreeViewColumn *col, gpointer user_data)
{  
	g_print("%s() : entering ... \n",__FUNCTION__);
  GemTreeView *view = GEM_TREE_VIEW(user_data);
  GtkTreeModel *model = NULL;
  GtkTreeIter iter;
  
	model = gem_tree_view_get_model(view);
	gtk_tree_view_get_cursor ((GtkTreeView *)(treeview), &path, &col);
	
  if (gtk_tree_model_get_iter (model, &iter, path))
  {
    gchar *uid = NULL;
  	gchar *storage = NULL;
		GtkWidget *cnt_load_window = NULL;
		GtkWidget *cnt_load_view = NULL;
		ab_contact_t *contact = NULL;
		
    gtk_tree_model_get (model, &iter,
												UI_COMP_CNT_LV_UID, 
												&uid, 
												UI_COMP_CNT_LV_STORAGE,
								  			&storage,
								  			-1);
							  			
//		g_print("%s()storage(%d) uid(%d)\n",__FUNCTION__,(gint)storage,uid);
		switch((gint)storage)
		{
			case STORAGE_LOCAL : 
						   ab_get_contact(ab_enabler_get_session(0), (ab_uid_t)uid, &contact);
							 action_cnt_modify_contact_local_cb(contact,uid);
							 break;
			case STORAGE_SIM: 
							 ab_get_contact(ab_enabler_get_session(1), (ab_uid_t)uid, &contact);
							 action_cnt_modify_contact_sim_cb(contact,uid); 
							 break;
//			case STORAGE_NON :							 
//
//							switch(atoi(uid))
//							{
//								case 1:
//												cnt_load_window = ui_comp_winmgr_get_window(UI_COMP_SKW_CNT_VIEW);
//												
//												if(cnt_load_window==NULL)
//												{
//													cnt_load_window = ui_comp_cnt_list_window_new();
//												}
//												else
//												{
//													cnt_load_view = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(cnt_load_window));	
//													ui_comp_cnt_list_view_update (cnt_load_view);
//												}
//												gtk_widget_show_all(cnt_load_window);
//												break;
//								case 2:
//												break;
//								case 3:
//												break;
//							}
//							break;
		}
    
  }

  return;
}

GType
ui_comp_cnt_list_view_get_type (void)
{
	static GType cnt_list_view_type = 0;

  if (!cnt_list_view_type)
	{
		static const GTypeInfo cnt_list_view_info =
		{
			sizeof (UICompCntListViewClass),
			NULL,		/* base_init */
			NULL,		/* base_finalize */
			(GClassInitFunc) ui_comp_cnt_list_view_class_init,
			NULL,		/* class_finalize */
			NULL,		/* class_data */
			sizeof (UICompCntListView),
			0,			/* n_preallocs */
			(GInstanceInitFunc) ui_comp_cnt_list_view_init,
			NULL,
		};

		cnt_list_view_type = g_type_register_static(GEM_TYPE_TREE_VIEW,
																								"UICompCntListView",
																								&cnt_list_view_info,
																								0);
	}

	return cnt_list_view_type;
}
void
ui_comp_cnt_list_view_update (UICompCntListView	*cntview)
{
	GtkTreePath *path = NULL;
	GtkTreeView *treeview = NULL;

  treeview = GTK_TREE_VIEW(gem_tree_view_get_view(GEM_TREE_VIEW(cntview)));  
	path = gtk_tree_path_new_first();
	gtk_tree_view_set_cursor(treeview,
													 path,
													 NULL,
													 TRUE);
  gtk_tree_path_free(path);
	return;
}

static void
ui_comp_cnt_list_view_class_init (UICompCntListViewClass * klass)
{
  GtkObjectClass *object_class;
  object_class = (GtkObjectClass*)klass;
  parent_class = g_type_class_peek_parent(klass);
	g_type_class_add_private(klass,
													 sizeof(UICompCntListViewPriv));
  object_class->destroy = ui_comp_cnt_list_view_destroy;
	return;
}

static void
ui_comp_cnt_list_view_destroy (GtkObject *object)
{
	UICompCntListView * cnt_list_view = UI_COMP_CNT_LIST_VIEW(object);
  (*GTK_OBJECT_CLASS(parent_class)->destroy)(object);
  
  return;
}

static void
ui_comp_cnt_list_view_init (UICompCntListView * cntview)
{
	UICompCntListViewPriv *priv = UI_COMP_CNT_LIST_VIEW_GET_PRIVATE(cntview);
	GtkWidget *treeview = NULL;
	GtkTreeViewColumn	*col = NULL;
	GtkCellRenderer *renderer = NULL;
	GtkListStore * liststore = NULL;
	
	g_print("%s(): invoke the gem_tree_get_view()\n",__FUNCTION__);
	treeview = gem_tree_view_get_view(GEM_TREE_VIEW(cntview));
	/* column name */
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Name");
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);
	
	renderer = gtk_cell_renderer_text_new();
	gtk_cell_renderer_set_fixed_size(renderer,
																	 130,
																	 -1);
/*	g_object_set(G_OBJECT(renderer),
							 "xalign",
							 1.0,
							 NULL);
	g_object_set(G_OBJECT(renderer),
							 "ypad",
							 5,
							 NULL);
*/	
	gtk_tree_view_column_pack_start(col,
																	renderer,
																	TRUE);
	gtk_tree_view_column_set_alignment(col,
																		 1);
	gtk_tree_view_column_add_attribute(col,
																		 renderer,
																		 "text",
																		 UI_COMP_CNT_LV_NAME);
	/* column pic */
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Picutre");
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);
	
	renderer = gtk_cell_renderer_pixbuf_new();
	gtk_cell_renderer_set_fixed_size(renderer,
																	 32,
																	 32);
	gtk_tree_view_column_pack_start(col,
																	renderer,
																	TRUE);
	gtk_tree_view_column_add_attribute(col,
																		 renderer,
																		 "pixbuf",
																		 UI_COMP_CNT_LV_PIC);
	
	liststore = gtk_list_store_new(NUM_UI_COMP_CNT_LV_COLS,
																 G_TYPE_UINT,
																 G_TYPE_UINT,
																 G_TYPE_STRING,
																 GDK_TYPE_PIXBUF,
																 G_TYPE_INT);
	
	gem_tree_view_set_model(GEM_TREE_VIEW(cntview),
													GTK_TREE_MODEL(liststore));													 
	g_object_unref(liststore);
	
	g_signal_connect (G_OBJECT ((GEM_TREE_VIEW(cntview))->treeview), "row-activated",
                    G_CALLBACK (ui_comp_cnt_list_view_row_activated), (gpointer) cntview);
                    
	priv->cntlist_hash = g_hash_table_new_full(g_int_hash,
																						 g_int_equal,
																						 g_free,
																						 gtk_tree_iter_free );                    
	return;
}

GtkWidget *
ui_comp_cnt_list_view_new (void)
{
	return gtk_widget_new(UI_COMP_TYPE_CNT_LIST_VIEW,
												NULL);
}

void
ui_comp_cnt_list_hash_table_insert(UICompCntListView *cntview,gpointer key, gpointer value)
{
	UICompCntListViewPriv *priv = UI_COMP_CNT_LIST_VIEW_GET_PRIVATE(cntview);
	gint *key_cp;
	key_cp = g_new0(guint32, 1);
	*key_cp = *(ab_uid_t *)key;
  g_hash_table_insert(priv->cntlist_hash,key_cp,value);
}

gboolean 
ui_comp_cnt_list_hash_table_remove(UICompCntListView *cntview,gpointer key)
{
	UICompCntListViewPriv *priv = UI_COMP_CNT_LIST_VIEW_GET_PRIVATE(cntview);
	if(g_hash_table_remove(priv->cntlist_hash,key))
		return TRUE;
	else
		return FALSE;
}

gpointer
ui_comp_cnt_list_hash_table_get(UICompCntListView *cntview, gpointer key)
{
	gpointer iter = NULL;
	UICompCntListViewPriv *priv = UI_COMP_CNT_LIST_VIEW_GET_PRIVATE(cntview);
	iter = g_hash_table_lookup(priv->cntlist_hash,key);
	return iter;
}

void
ui_comp_cnt_list_hash_table_remove_all(UICompCntListView *cntview)
{
	UICompCntListViewPriv *priv = UI_COMP_CNT_LIST_VIEW_GET_PRIVATE(cntview);
  g_hash_table_foreach(priv->cntlist_hash,g_hash_table_remove,NULL);
}

/*
vi:ts=2:nowrap:ai:expandtab 
*/
