/*	contact - LiPS Address Book Application
 *
 *	Authors: YE Nan <nan.ye@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef __UI_COMP_SK_WINDOW_PRV_H
#define __UI_COMP_SK_WINDOW_PRV_H

#include <gtk/gtk.h>
#include <glib.h>
#include <gpe/gpeskwindow.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _UICompSKWindowPriv UICompSKWindowPriv;

struct _UICompSKWindowPriv
{
	GtkWidget 		*label;
	GtkWidget 		*viewport;
	GtkWidget			*view;
	GtkUIManager	*uimgr;
};

#define UI_COMP_SKWINDOW_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE((obj), \
																					 UI_COMP_TYPE_SKWINDOW, \
																					 UICompSKWindowPriv));

void	ui_comp_skwindow_set_view						(UICompSKWindow			*skwindow,
																					 GtkWidget					*view,
																					 gchar					 	 *title);

void	ui_comp_skwindow_parse_sk_conf			(UICompSKWindow			*skwindow,
																					 const gchar				*left_sk_label,
																					 const gchar				*right_sk_label,
																					 const gchar				*sk_uidesc,
																					 GtkActionEntry			*sk_actions,
																					 guint							 n_sk_actions);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __UI_COMP_SK_WINDOW_PRV_H */

/*
vi:ts=2:nowrap:ai:expandtab
*/
