/*	uiwincntlist.c - UI Window Contact List View
 *
 *	Authors: YE Nan <nan.ye@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */
#include <stdio.h>
#include <stdlib.h>

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gemhashview.h>

#include <uicompskwindow.h>
#include <uicompcntlstview.h>

#include "uiwincntlist.h"

typedef struct _UIWinCntListPriv UIWinCntListPriv;

struct _UIWinCntListPriv
{
	gpointer	 dummy;
};

#define UI_WIN_CNT_LIST_GET_PRIVATE(obj)	(G_TYPE_INSTANCE_GET_PRIVATE((obj), \
																					 UI_WIN_TYPE_CNT_LIST, \
																					 UIWinCntListPriv));

static void		ui_win_cnt_list_class_init		(UIWinCntListClass			*klass);
static void		ui_win_cnt_list_init					(UIWinCntList						*listwin);
static void		ui_win_cnt_list_finalize			(GObject								*object);


static void		ui_win_cnt_list_softkey_cb		(UIWinCntList						*listwin,
																						 gint										 nr,
																						 gpointer								 storage);

static UICompSKWindowClass * parent_class = NULL;

GType
ui_win_cnt_list_get_type (void)
{
	static GType window_type = 0;

  if (!window_type)
	{
		static const GTypeInfo window_info =
		{
			sizeof (UIWinCntListClass),
			NULL,		/* base_init */
			NULL,		/* base_finalize */
			(GClassInitFunc) ui_win_cnt_list_class_init,
			NULL,		/* class_finalize */
			NULL,		/* class_data */
			sizeof (UIWinCntList),
			0,			/* n_preallocs */
			(GInstanceInitFunc) ui_win_cnt_list_init,
			NULL,
		};
		
		window_type = g_type_register_static(UI_COMP_TYPE_SKWINDOW,
																				 "UIWinCntList",
																				 &window_info,
																				 0);
	}
	return window_type;
}

static void
ui_win_cnt_list_class_init (UIWinCntListClass * klass)
{
  GtkObjectClass *object_class;

  object_class = (GtkObjectClass*)klass;

  parent_class = g_type_class_peek_parent(klass);

	g_type_class_add_private(klass,
													 sizeof(UIWinCntListPriv));

	return;
}

static void
ui_win_cnt_list_init (UIWinCntList *listwin)
{
	UIWinCntListPriv *priv = UI_WIN_CNT_LIST_GET_PRIVATE(listwin);
	GtkWidget *view = NULL;
	
/*	ui_comp_skwindow_parse_sk_conf(UI_COMP_SKWINDOW(listwin),
																 "Options",
																 "Cancel",
																 NULL,
																 NULL,
																 0);
*/
	view = ui_comp_cnt_lst_view_new();
	ui_comp_skwindow_set_view(UI_COMP_SKWINDOW(listwin),
														view,
														"Contacts");

/*	g_signal_connect(G_OBJECT(listwin),
									 "softkey-activated",
									 G_CALLBACK(ui_win_cnt_list_softkey_cb),
									 NULL);							 
*/
	return;
}

GtkWidget *
ui_win_cnt_list_new (void)
{
	UIWinCntListPriv *priv = NULL;
	GtkWidget *window = NULL;
	GtkWidget *listview = NULL;
	
	window = gtk_widget_new(UI_WIN_TYPE_CNT_LIST,
													NULL);
	
	listview = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(window));

	return window;
}

static void
ui_win_cnt_list_softkey_cb (UIWinCntList	*listwin,
														gint					 nr,
														gpointer			 storage)
{
	UIWinCntListPriv *priv = UI_WIN_CNT_LIST_GET_PRIVATE(listwin);
	gboolean updated = FALSE;
  gboolean ret = FALSE;
 	
  if (nr == UI_COMP_SK_LEFT)
  {
    ret = TRUE;
  }
	else if (nr == UI_COMP_SK_RIGHT)
  {
    ret = TRUE;
  }

  if (ret)
  {
		gtk_widget_hide_all(GTK_WIDGET (listwin));			
	}

  return;
}

/*
vi:ts=2:nowrap:ai:expandtab 
*/
