/*  addressbook - Address book
 *abookservices.c - 
 *
 *Authors: YE Nan <nan.ye@orange-ftgroup.com>
 *        ZHAO Liangjing <liangjing.zhao@orange-ftgroup.com> 
 *
 *This software and associated documentation files (the "Software") 
 *are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *All Rights Reserved. 
 *
 *A copyright license is hereby granted for redistribution and use of 
 *the Software in source and binary forms, with or without modification, 
 *provided that the following conditions are met: 
 *- Redistributions of source code must retain the above copyright notice, 
 *this copyright license and the following disclaimer. 
 *- Redistributions in binary form must reproduce the above copyright 
 *notice, this copyright license and the following disclaimer in the 
 *documentation and/or other materials provided with the distribution. 
 *- Neither the name of LiPS  nor the names of its Members may be used 
 *to endorse or promote products derived from the Software without 
 *specific prior written permission. 
 *
 *A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *distribute any implementation compliant with the any specification adopted 
 *by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *and non-discriminatory terms and conditions and under reciprocity, as 
 *regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *POSSIBILITY OF SUCH DAMAGE. 
 */


#include <stdio.h>
#include <stdlib.h>
//#include <uuid/uuid.h>
//#include <pim.h>
#include <gtk/gtk.h>
#include <gpe/init.h>
#include <gdk/gdkkeysyms.h>
#include <gpe/gpeskwindow.h>
#include <uicompwinmgr.h>
#include <uicompcntlistview.h>
#include <uicomptreeviewcnt.h>
#include <gtkautoscrolledwindow.h>
#include <gemnotification.h>
#include <uicompskwindow.h>
#include "enabler.h"
#include "dbus.h"
#include "dbus-shared.h"
#include "internal.h"

NumberPair *
number_pair_new (const gchar *name, const gchar *number)
{
  NumberPair *pair = NULL;

  if (name == NULL || number == NULL)
  {
    return NULL;
  }

  pair = g_new0 (NumberPair, 1);
  if (pair == NULL)
  {
    return NULL;
  }

  pair->name = g_strdup (name);
  pair->number = g_strdup (number);

  return pair;
}


void
number_pair_free (NumberPair *pair)
{
  if (pair == NULL)
  {
    return;
  }

  if (pair->name)
  {
    g_free (pair->name);
  }

  if (pair->number)
  {
    g_free (pair->number);
  }

  g_free (pair);

  return;
}

void
service_mw_send_message_hide_cb (GtkWidget *widget, UICompTreeViewCnt *view)
{
//  if (view->status == MARK_VIEW_STATUS_SAVE)
//  {
//    GPtrArray *number_pairs = NULL;
//
//    g_print ("%s(): entering\n", __FUNCTION__);
//
//    number_pairs = g_ptr_array_new ();
//
//    if (view)
//    {
//      GtkTreeView *treeview = GTK_TREE_VIEW (view->treeview);
//      GtkTreeModel *model = NULL;
//
//      model = gtk_tree_view_get_model (treeview);
//      if (model)
//      {
//        GtkTreeIter toplevel;
//
//        if (gtk_tree_model_get_iter_first (model, &toplevel))
//        {
//          do
//          {
//            gchar *name = NULL;
//            GtkTreeIter iter;
//
//            gtk_tree_model_get (model, &toplevel, COL_MV_STRING, &name, -1);
//
//            if (gtk_tree_model_iter_children (model, &iter, &toplevel))
//            {
//              do
//              {
//                gchar *number = NULL;
//                gboolean checked = FALSE;
//
//                gtk_tree_model_get (model, &iter,
//                                    COL_MV_STRING, &number,
//                                    COL_MV_CHECK, &checked, -1);
//
//                if (checked)
//                {
//                  NumberPair *pair = NULL;
//
//                  // g_print("%s(): number = %s\n", __FUNCTION__, number);
//                  pair = number_pair_new (name, number);
//                  if (pair)
//                  {
//                    g_ptr_array_add (number_pairs, (gpointer) pair);
//                  }
//                }
//
//                g_free (number);
//              } while (gtk_tree_model_iter_next (model, &iter));
//            }
//
//            g_free (name);
//          } while (gtk_tree_model_iter_next (model, &toplevel));
//        }
//      }
//    }
//
//    abook_iac_multi_sms (number_pairs);
//    if (TRUE)
//    {
//      gint i;
//      gint count;
//
//      count = number_pairs->len;
//      for (i = 0; i < count; i++)
//      {
//        NumberPair *pair = NULL;
//
//        pair = (NumberPair *) g_ptr_array_remove_index_fast (number_pairs, 0);
//        g_print ("%s(): pair [%20s, %s]\n", __FUNCTION__, pair->name,
//                 pair->number);
//
////        number_pair_free (pair);
//      }
//    }
//
//    g_ptr_array_free (number_pairs, TRUE);
//  }
//
//  if (abook_iac_invoked_app () == TRUE)
//  {
//    gtk_main_quit ();
//  }

  return;
}

GtkWidget *
main_window_service_send_message_init (void)
{
  GtkWidget *main_window = NULL;

//  main_window = abook_skw_markview_new (UI_COMP_SKW_MAKR_VIEW_SIMPLE);

  if (TRUE)
  {
    UICompSKWindow *sk_window = ui_comp_winmgr_get_window (UI_COMP_SKW_MAKR_VIEW_SIMPLE);
    GtkWidget *view = ui_comp_skwindow_get_view(sk_window);

    ab_enabler_ui_comp_tree_view_cnt_parse_contacts (UI_COMP_TREE_VIEW_CNT(view), TRUE);
    g_signal_connect (G_OBJECT (view),
                      "hide",
                      G_CALLBACK (service_mw_send_message_hide_cb),
                      view);
  }

  return main_window;
}

static void
mw_contact_view_softkey_activated_cb (GpeSKWindow *window,
                                      gint nr, gpointer user_data)
{
  g_print ("%s(): entring\n", __FUNCTION__);
  gtk_main_quit ();

  return;
}

//GtkWidget *
//main_window_service_add_contact_init (void)
//{
//  GtkWidget *main_window = NULL;
//
//  main_window = abook_skw_contact_view_new (NULL, TRUE, TRUE, FALSE);
//  if (TRUE)
//  {
//    UICompSKWindow *sk_window = abook_skw_get_skwindow (SKW_CNT_VIEW_EDIT);
//
////    g_print ("%s(): gpewindow = 0x%08x\n",
////             __FUNCTION__, (guint32) sk_window->window);
//
//    g_signal_connect (G_OBJECT (sk_window->window),
//                      "softkey_activated",
//                      G_CALLBACK (mw_contact_view_softkey_activated_cb), NULL);
//  }
//
//  return main_window;
//}

//GtkWidget *
//main_window_service_call_init (void)
//{
//  GtkWidget *main_window = NULL;
//
//  main_window = abook_skw_list_view_new ();
//
//  if (TRUE)
//  {
//    gint i;
////    ab_uuid_t **uuids = NULL;
////    ABookSKWindow *window = abook_skw_get_skwindow (SKW_LIST_VIEW);
////    ABookListView *view = ABOOK_LISTVIEW (window->view);
//		GtkWidget *window = NULL;
//		GtkWidget *view = NULL;
//		window = ui_comp_winmgr_get_window(UI_COMP_SKW_CNT_VIEW);
//		view = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(window));
//		
//    uuids = ab_get_contact_ids (abook_enabler_local_session (), NULL);
//
//    if (uuids)
//    {
//      for (i = 0; uuids[i] != NULL; i++)
//      {
//        ab_contact_t *contact = NULL;
//
//        ab_get_contact (abook_enabler_local_session (), *(uuids[i]), &contact);
//        g_free (uuids[i]);
//
//        GDK_THREADS_ENTER ();
//        abook_listview_add_contact (view, contact);
//        GDK_THREADS_LEAVE ();
//
//        ab_contact_free (contact);
//      }
//
//      g_free (uuids);
//    }
//
//    uuids = ab_get_contact_ids (abook_enabler_sim_session (), NULL);
//
//    if (uuids)
//    {
//      for (i = 0; uuids[i] != NULL; i++)
//      {
//        ab_contact_t *contact = NULL;
//
//        ab_get_contact (abook_enabler_sim_session (), *(uuids[i]), &contact);
//        g_free (uuids[i]);
//
//        GDK_THREADS_ENTER ();
//        abook_listview_add_contact_sim (view, contact);
//        GDK_THREADS_LEAVE ();
//
//        ab_contact_free (contact);
//      }
//
//      g_free (uuids);
//    }
//  }
//
//  return main_window;
//}

/* 
vi:ts=2:nowrap:ai:expandtab
*/

