/*	contact - LiPS Address Book Application
 *
 *	Authors: YE Nan <nan.ye@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <gtk/gtk.h>
#include <gem.h>
#include <gemnotification.h>
#include <uicompmainwindow.h>
#include <uicompskwindow.h>
#include "dbus.h"
#include "enabler.h"


#define MAX_CNT_NUM 50

/* read the rc file */
gboolean
file_exists (const char *filename)
{
  struct stat statbuf;

  return stat (filename, &statbuf) == 0;
}


static void
ab_generate_demo_contacts (void)
{
  gint i;
  for (i = 0; i < MAX_CNT_NUM; i++)
  {
    ab_contact_t *contact = NULL;
    gchar *values[AB_IV_NUM];
    gint index;
    for(index = 0; index < AB_IV_NUM;index++)
    {
    	values[index] = g_new0(gchar, 1);

    }

    values[AB_IV_FULL_NAME] = g_strdup_printf ("person%02d", i);
    values[AB_IV_MOBILE_NUM] =
      g_strdup_printf ("+86%3d%08d", g_random_int_range (135, 139),
                       g_random_int_range (0, 99999999));
    values[AB_IV_HOME_NUM] = g_strdup_printf ("+86%8d", g_random_int_range (0, 99999999));
    values[AB_IV_BUSINESS_NUM] = g_strdup_printf ("+86%8d", g_random_int_range (0, 99999999));
    values[AB_IV_FAX_NUM] = g_strdup_printf ("+86%8d", g_random_int_range (0, 99999999));
    values[AB_IV_COMPANY] = g_strdup_printf ("company%02d", i);
    values[AB_IV_DEPARTMENT] = g_strdup_printf ("depart%02d", i);
    values[AB_IV_WEBSITE] = g_strdup_printf ("http://spaces.our.com/person%02d", i);
    values[AB_IV_EMAIL] = g_strdup_printf ("person%02d@our.com", i);
    values[AB_IV_PICTURE] = g_strdup_printf ("icon0%d.png", g_random_int_range (1, 6));
    values[AB_IV_HOME_STREET] = g_strdup_printf ("room%2d, abc Road, Beijing, China", i);
    values[AB_IV_BUSI_STREET] = g_strdup_printf ("room%2d, def Road, Beijing, China", i);

    ab_create_contact (ab_enabler_get_session(SESSION_LOCAL), &contact);
    g_print("%s(): contact(0x%08x)          #########\n\n",__FUNCTION__,(guint32)contact);
    for (index = 0; index < AB_IV_NUM; index++)
    {
//    	g_print("%s(): index = %d\n",__FUNCTION__,index);
//      if (g_random_boolean () && strlen(values[index]) >1 )
//      {
//      	ab_fid_t fid = 0;
//      	
//      	ab_contact_get_default_field (contact,index,&fid);
//      	g_print("%s(): fid = %d, values[%d] = %s \n",__FUNCTION__,fid,index,values[index]);
//      	ab_contact_set_string_field (contact, fid,values[index]);
////        ab_contact_set_field (contact, index + 2, (gpointer) values[index]);
//      }
				if (strlen(values[index]) >1 )
				{
					g_print("%s(): contact(0x%08x)           ^^^^^^^^^^^^\n\n",__FUNCTION__,(guint32)contact);
					switch(index)
					{
		 				case AB_IV_FULL_NAME : ab_contact_set_full_name(contact, values[index]);
									   break;
						case AB_IV_MOBILE_NUM : ab_contact_set_mobile_num(contact, values[index]); 
						 				 break;
						case AB_IV_HOME_NUM : ab_contact_set_home_num(contact, values[index]);
						  			 break;
						case AB_IV_BUSINESS_NUM : ab_contact_set_business_num(contact, values[index]);
										 break;
						case AB_IV_FAX_NUM :  ab_contact_set_fax_num(contact, values[index]);
										 break;
						case AB_IV_COMPANY : 	ab_contact_set_company(contact, values[index]);
										 break;
					  case AB_IV_DEPARTMENT : ab_contact_set_department(contact, values[index]);
					  				 break;
						case AB_IV_WEBSITE : ab_contact_set_website(contact, values[index]);
										 break;
						case AB_IV_EMAIL : ab_contact_set_email(contact, values[index]);		
										 break;	
						case AB_IV_PICTURE : ab_contact_set_picture(contact, values[index]);	
										 break;
						case AB_IV_RINGTONE : ab_contact_set_ringtone(contact, values[index]);		
											break;
						case AB_IV_HOME_STREET : ab_contact_set_home_street(contact, values[index]);
											break;
						case AB_IV_BUSI_STREET : ab_contact_set_business_street(contact, values[index]);
											break;
					}
				}
      g_free (values[index]);
    }
    ab_contact_print (contact);
    ab_uid_t uid = AB_ID_INVALID;    
    ab_add_contact (ab_enabler_get_session(SESSION_LOCAL), contact,&uid);
//    ab_add_contact (abook_enabler_local_session (), contact);

//    if (TRUE)
//    {
//      ab_category_t **results = NULL;
//
//      results = ab_get_categories (abook_enabler_local_session (), NULL);
//      if (results)
//      {
//        gint j;
//        gpointer contact_uid;
//
//        ab_contact_get_field (contact, CNT_UID, (gpointer) & contact_uid);
//
//        for (j = 0; results[j] != NULL; j++)
//        {
//          ab_category_print (results[j]);
//
//          if (g_random_boolean ())
//          {
//            gpointer category_uid;
//
//            ab_category_get_field (results[j], CAT_UID,
//                                   (gpointer) & category_uid);
//            ab_ref_contact_category (abook_enabler_local_session (),
//                                     (ab_uuid_t *) contact_uid,
//                                     (ab_uuid_t *) category_uid);
//
//            g_free (category_uid);
//          }
//
//          ab_category_free (results[j]);
//        }
//
//        g_free (contact_uid);
//        g_free (results);
//      }
//    }
    ab_contact_free (contact);
  }

  return;
}

int main (int argc, char *argv[])
{
	GtkWidget *window = NULL;
	GtkWidget *view = NULL;
	GemApplication *app = NULL;
  gchar *file_path = NULL;
	gtk_init(&argc, &argv);
	
//  file_path = g_strdup_printf ("%s", "/opt/workspace/host/common/source/lipsri/contacts/graphic/rc/testgtkrc");
//  if (file_exists (file_path))
//    gtk_rc_add_default_file (file_path);
	
	if (abook_iac_initialize () == FALSE)
  {
    g_print ("%s(): abook_dbus_init() failure\n", __FUNCTION__);
    return EXIT_FAILURE;
  }
	
	if (!g_thread_supported())
	{
		g_thread_init(NULL);
		gdk_threads_init();
	}
	
	
	ab_enabler_initialize();
	
//	ab_remove_contacts(ab_enabler_get_session(SESSION_LOCAL), NULL);
//  ab_generate_demo_contacts();
	window = ui_comp_main_window_new();
//	g_signal_connect(G_OBJECT(window),
//									 "show",
//									 G_CALLBACK(main_window_show_cb),
//									 NULL);
									 	
	view = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(window));
		
	
//	ui_comp_cnt_list_view_update(view);
	app = gem_application_get_instance();
	gem_application_set_main_window(app,
																	window);
	gem_application_run(app);
	gem_application_destroy(app);
	ab_enabler_finalize();
	
	return EXIT_SUCCESS;
}





/*
vi:ts=2:nowrap:ai:expandtab 
*/
