/*	contact - LiPS Address Book Application
 *
 *	Authors: YE Nan <nan.ye@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */
#include <stdio.h>
#include <glib.h>
#include <gpe/gpeskwindow.h>
#include <gem.h>
#include <gtk/gtk.h>
#include <uicompcateditview.h>
#include <uicompcatlistview.h>
#include <uicompmainwindow.h>
#include <uicompwinmgr.h>
#include <uicompskwindow.h>
#include <gemfilechooser.h>
#include <abcategory.h>
#include "enabler.h"
#include "threads.h"

static gboolean picture_flag = FALSE;
static gboolean ringtone_flag = FALSE;

static void ui_comp_file_chooser_selected_cb(GemFileChooser *fileview,gchar *kind);
static void ui_comp_file_chooser_softkey_activated_cb(GpeSKWindow *window,
																											gint nr,
																											gchar *kind);

static void
softkey_activated_cb (GpeSKWindow		*window,
											gint					 nr,
											gpointer			 user_data)
{
	g_print("%s(): entering\n",
					__FUNCTION__);
	if (nr == UI_COMP_SK_LEFT)
	{
		g_print("%s(): left activated\n",
						__FUNCTION__);
	}
	else if (nr == UI_COMP_SK_RIGHT)
	{
		gtk_widget_hide_all(GTK_WIDGET(window));
	}	
	return;
}

//void cat_window_show_cb(GtkWidget	*widget,
//												gpointer		 user_data)
//{
//	GtkWidget *view = NULL;
////	ab_thread_t *thread1 = NULL;
//	view = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(widget));	
//
//	g_print("%s () :  widget = 0x%08x  ............\n",__FUNCTION__,widget);	
////
////	thread1 = ab_thread_create(ab_enabler_cat_list_view_load_category_thread,
////														(gpointer)view,
////									 					FALSE);									
//	ab_enabler_cat_list_view_load_category(view);													
////	ab_thread_run(thread1);
//	return;
//}

//void action_cat_list_category_cb()
//{
//  GtkWidget *window = NULL;
//  ab_uid_t *uid = AB_ID_INVALID;
//  window = ui_comp_winmgr_get_window (UI_COMP_SKW_CAT_VIEW);
//  uid = (ab_uid_t)action_get_current_contact_uid (UI_COMP_SKWINDOW(window));
//	mw_cat_list_view_row_cb(uid);	
//	return;				     
//}

static void 
ui_comp_category_modify_pic_entry_in_cb(GtkWidget *entry, GdkEventFocus *event,UICompSKWindow	*skwindow)
{ 
	g_print("%s(): entering... \n",__FUNCTION__);	
	g_print("%s(): entry = 0x%08x, skwindow = 0x%08x \n",__FUNCTION__,(guint32)entry, (guint32)skwindow);
	gpe_skwindow_set_softkey_label(GPE_SKWINDOW(skwindow),UI_COMP_SK_LEFT,"Modify");
	picture_flag = TRUE;
}

static void 
ui_comp_category_modify_pic_entry_out_cb(GtkWidget *entry, GdkEventFocus *event,UICompSKWindow	*skwindow)
{ 
	gpe_skwindow_set_softkey_label(GPE_SKWINDOW(skwindow),UI_COMP_SK_LEFT,"Save");
	picture_flag = FALSE;
}

static void 
ui_comp_category_modify_ring_entry_in_cb(GtkWidget *entry, GdkEventFocus *event,UICompSKWindow	*skwindow)
{ 
	g_print("%s(): entering... \n",__FUNCTION__);	
	g_print("%s(): entry = 0x%08x, skwindow = 0x%08x \n",__FUNCTION__,(guint32)entry, (guint32)skwindow);
	gpe_skwindow_set_softkey_label(GPE_SKWINDOW(skwindow),UI_COMP_SK_LEFT,"Modify");
	ringtone_flag = TRUE;
}

static void 
ui_comp_category_modify_ring_entry_out_cb(GtkWidget *entry, GdkEventFocus *event,UICompSKWindow	*skwindow)
{ 
	gpe_skwindow_set_softkey_label(GPE_SKWINDOW(skwindow),UI_COMP_SK_LEFT,"Save");
	ringtone_flag = FALSE;
}

static void
ui_comp_file_chooser_softkey_activated_cb(GpeSKWindow *window,
																					gint nr,
																					gchar *kind)
{
	GtkWidget *fileview = NULL;
	fileview = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(window));	
	if(nr == UI_COMP_SK_LEFT)
	{
		GList *select_list = NULL;
		gchar *picpath = NULL;
		gchar *chooser = NULL;
		GtkWidget *EditWindow = NULL;
		GtkWidget *editview = NULL;
		select_list = gem_file_chooser_get_current_selections(fileview);
		if(select_list==NULL || g_list_length (select_list) ==0)
		{
			return;
		}
		
		g_print("%s(): g_list_length (select_list) = %d \n",__FUNCTION__,g_list_length (select_list));
		
		chooser = g_list_nth_data (select_list, 0);
		
		picpath = g_build_filename(gem_file_chooser_get_current_path(GEM_FILE_CHOOSER(fileview)),
														   chooser,
														   NULL);												 
  	
   	EditWindow = ui_comp_winmgr_get_window(UI_COMP_SKW_CAT_VIEW_EDIT);
  	editview = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(EditWindow)); 
  	if(chooser!=NULL && (g_strcasecmp(kind, "pic") == 0))
  	{
  		gem_hash_view_set_value	(GEM_HASH_VIEW(editview),CAT_PICTURE,chooser);
  	} 
  	
  	if(chooser!=NULL && (g_strcasecmp(kind, "ring") == 0))
  	{
  		gem_hash_view_set_value	(GEM_HASH_VIEW(editview),CAT_RINGTONE,chooser);
  	}	
	}
	else if (nr == UI_COMP_SK_RIGHT)
	{
	}
	gtk_widget_hide_all (GTK_WIDGET (window));
	g_object_disconnect(G_OBJECT(window),
										 "any_signal::softkey_activated",
										  ui_comp_file_chooser_softkey_activated_cb,
										  kind,
										  NULL);
	g_object_disconnect(G_OBJECT(fileview),
										 "any_signal::file_selected",
											ui_comp_file_chooser_selected_cb,
											kind,
											NULL);										
}

static void
ui_comp_category_view_hide_cb (GtkWidget *widget, gpointer user_data)
{
  GtkWidget *ListWindow = NULL; 
  GtkWidget *EditWindow = NULL;
  GtkWidget *listview = NULL;
  GtkWidget *editview = NULL;
  
  ListWindow = ui_comp_winmgr_get_window(UI_COMP_SKW_CAT_VIEW);
  listview =  ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(ListWindow)); 
  
  EditWindow = ui_comp_winmgr_get_window(UI_COMP_SKW_CAT_VIEW_EDIT);
  editview = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(EditWindow)); 
  
  g_print("%s(): entering\n", __FUNCTION__);
  if (editview)
  {
    g_print ("%s():status = %s\n", __FUNCTION__,
             (GEM_HASH_VIEW(editview)->status == GEM_HV_STATUS_SAVE) ? "TRUE" : "FALSE");
    if (GEM_HASH_VIEW(editview)->status == GEM_HV_STATUS_SAVE)
    {
      const gchar *uidstr = NULL;      
//      g_print("%s(): editview = 0x%08x \n  listview = 0x%08x \n",__FUNCTION__,(guint32)editview,(guint32)listview);
      uidstr = gem_hash_view_get_value(GEM_HASH_VIEW(editview),CAT_UID);
      
      if (uidstr)
      {
        GtkTreeIter iter;        
        ab_category_t *category = NULL;        
				ab_uid_t uid = atoi(uidstr);
  			ab_get_category (ab_enabler_get_session(0), uid, &category);
  			
       ab_category_print (category);
        if (ab_enabler_ui_comp_list_view_find (listview, uid, &iter))
        {
        	g_print("%s(): listview = 0x%08x \n",__FUNCTION__,listview);
					ab_enabler_ui_comp_cat_list_view_update (UI_COMP_CAT_LIST_VIEW(listview), category, &iter);
		
        }
        else
        {
        	g_print("%s(): listview = 0x%08x \n",__FUNCTION__,listview);
					ab_enabler_ui_comp_cat_list_view_update (UI_COMP_CAT_LIST_VIEW(listview), category, NULL);
			    ui_comp_cat_list_view_update(UI_COMP_CAT_LIST_VIEW(listview));
        }
        gem_tree_view_set_search_column(GEM_TREE_VIEW(listview),UI_COMP_CAT_LV_NAME,GTK_SORT_ASCENDING,NULL);        
        ab_category_free(category);
      }
    }

  }
  return;
}
static void 
ui_comp_file_chooser_selected_cb(GemFileChooser *fileview,gchar *kind)
{
	g_print("%s(): entering ...............................\n\n",__FUNCTION__);
	GList *select_list = NULL;
	gchar *picpath = NULL;
	gchar *chooser = NULL;
	GtkWidget *EditWindow = NULL;
	GtkWidget *editview = NULL;
	GtkWidget *filewindow = NULL;
	filewindow = ui_comp_winmgr_get_window(UI_COMP_SKW_FILE_CHOOSER);
	select_list = gem_file_chooser_get_current_selections(fileview);
	if(select_list==NULL || g_list_length (select_list) ==0)
	{
		return;
	}
	
	g_print("%s(): g_list_length (select_list) = %d \n",__FUNCTION__,g_list_length (select_list));
	
	chooser = g_list_nth_data (select_list, 0);
	
	picpath = g_build_filename(gem_file_chooser_get_current_path(GEM_FILE_CHOOSER(fileview)),
													   chooser,
													   NULL);
	EditWindow = ui_comp_winmgr_get_window(UI_COMP_SKW_CAT_VIEW_EDIT);
  editview = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(EditWindow));	

g_print("%s() : kind = %s \n",__FUNCTION__,kind ? kind : "null");				 											 
	if(chooser!=NULL && (g_strcasecmp(kind, "pic") == 0))
	{
g_print("%s() : kind = %s \n",__FUNCTION__,kind ? kind : "null");	
		gem_hash_view_set_value	(GEM_HASH_VIEW(editview),CAT_PICTURE,chooser);
	} 
	
	if(chooser!=NULL && (g_strcasecmp(kind, "ring") == 0))
	{
g_print("%s() : kind = %s \n",__FUNCTION__,kind ? kind : "null");	
		gem_hash_view_set_value	(GEM_HASH_VIEW(editview),CAT_RINGTONE,chooser);
	}	

	gtk_widget_hide_all (GTK_WIDGET (filewindow));
	
	g_object_disconnect(G_OBJECT(filewindow),
										 "any_signal::softkey_activated",
										  ui_comp_file_chooser_softkey_activated_cb,
										  kind,
										  NULL);
	g_object_disconnect(G_OBJECT(fileview),
										 "any_signal::file_selected",
											ui_comp_file_chooser_selected_cb,
											kind,
											NULL);
}


void ui_comp_category_view_softkey_add_activated_cb(GpeSKWindow *window,
			                                        		  gint nr)
{
  gboolean ret = FALSE;
  const gchar *left_label = NULL;
  GtkWidget *view = NULL;
  GtkWidget *skwindow = NULL;
 	GtkWidget *listview = NULL;

  skwindow = ui_comp_winmgr_get_window (UI_COMP_SKW_CAT_VIEW);
  listview = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(skwindow));
 	view = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(window));
	
  if (nr == UI_COMP_SK_LEFT && !picture_flag && !ringtone_flag)
  {
    g_print ("%s(): Left Softkey      \n", __FUNCTION__);
    if (view && gem_hash_view_get_editable (GEM_HASH_VIEW(view)))
    {
      ab_category_t *category = NULL;
      ab_enabler_cat_parse_from_edit_view (GEM_HASH_VIEW(view), &category);
      	
      ab_category_print (category);      
      if (category)
      {
        ab_uid_t uid = AB_ID_INVALID;    
  			  		  
        gchar *tmpuid = NULL;
        tmpuid = g_new0(gchar, 6);
        ab_add_category (ab_enabler_get_session(0), category,&uid);
        ab_category_get_uid (category,&uid);
  			g_sprintf (tmpuid, "%d",uid);
  				
  			GtkWidget *EditWindow = NULL;
  			GtkWidget *editview = NULL;
  				
  			EditWindow = ui_comp_winmgr_get_window(UI_COMP_SKW_CAT_VIEW_EDIT);
  			editview = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(EditWindow)); 
  				
        gem_hash_view_set_value (GEM_HASH_VIEW(editview), CAT_UID, tmpuid);
 				g_print("%s(): uid = %d     \n",__FUNCTION__,uid);    
        g_free (tmpuid); 
       }
      ab_category_free (category);
    }
    ret = TRUE;
  }
 
  else if (nr == UI_COMP_SK_LEFT && picture_flag)    
  {
  	GtkWidget *fileview = NULL;
  	GtkWidget *filewindow = NULL;
  	
  	filewindow = ui_comp_winmgr_get_window(UI_COMP_SKW_FILE_CHOOSER);
  	if(filewindow == NULL)
  	{  	  	
  		fileview = gem_file_chooser_new();
  		gem_file_chooser_set_selectable(GEM_FILE_CHOOSER(fileview),FALSE);
  		gchar *picpath = NULL;
  		picpath = g_build_filename(gem_env_get_resource_path(),
																 "pixmaps",
																  NULL,
																  NULL);
  		g_print("%s(): picpath = %s  \n",__FUNCTION__,picpath);
	  	gem_file_chooser_set_current_path(GEM_FILE_CHOOSER(fileview),picpath);  		
			filewindow = ui_comp_skwindow_new(fileview,
																				"Ok",
																				"Cancel",															
																				"",
																				NULL,
																				0,
																				NULL);																	 
			g_signal_connect(G_OBJECT(filewindow),
											 "softkey_activated",
											 G_CALLBACK(ui_comp_file_chooser_softkey_activated_cb),
											 "pic");	
			g_signal_connect(G_OBJECT(fileview),
											 "file_selected",
											 G_CALLBACK(ui_comp_file_chooser_selected_cb),
											 "pic");	
			ui_comp_winmgr_register_window(UI_COMP_SKW_FILE_CHOOSER,
																		 filewindow);		
  	}					
  	else
  	{
  		g_print("%s() ...............................\n",__FUNCTION__);
  		gchar *picpath = NULL;
  		fileview = ui_comp_skwindow_get_view (UI_COMP_SKWINDOW(filewindow));
  		picpath = g_build_filename(gem_env_get_resource_path(),
																 "pixmaps",
																  NULL,
																  NULL);
  		g_print("%s(): picpath = %s  \n",__FUNCTION__,picpath ? picpath : "null");
	  	gem_file_chooser_set_current_path(GEM_FILE_CHOOSER(fileview),picpath);
			g_signal_connect(G_OBJECT(filewindow),
											 "softkey_activated",
											 G_CALLBACK(ui_comp_file_chooser_softkey_activated_cb),
											 "pic");	
			g_signal_connect(G_OBJECT(fileview),
											 "file_selected",
											 G_CALLBACK(ui_comp_file_chooser_selected_cb),
											 "pic");		  	
  	}	 
  	gtk_widget_show_all(filewindow);
  }  
  
  else if (nr == UI_COMP_SK_LEFT && ringtone_flag)    
  {
  	GtkWidget *fileview = NULL;
  	GtkWidget *filewindow = NULL;  	
  	filewindow = ui_comp_winmgr_get_window(UI_COMP_SKW_FILE_CHOOSER);
  	if(filewindow == NULL)
  	{  	  	
  		fileview = gem_file_chooser_new();
  		gem_file_chooser_set_selectable(GEM_FILE_CHOOSER(fileview),FALSE);
  		gchar *picpath = NULL;
  		picpath = g_build_filename(gem_env_get_resource_path(),
																 "sounds",
																  NULL,
																  NULL);
  		g_print("%s(): picpath = %s  \n",__FUNCTION__,picpath);
	  	gem_file_chooser_set_current_path(GEM_FILE_CHOOSER(fileview),picpath);  		
			filewindow = ui_comp_skwindow_new(fileview,
																				"Ok",
																				"Cancel",															
																				"",
																				NULL,
																				0,
																				NULL);																	 
			g_signal_connect(G_OBJECT(filewindow),
											 "softkey_activated",
											 G_CALLBACK(ui_comp_file_chooser_softkey_activated_cb),
											 "ring");	
			g_signal_connect(G_OBJECT(fileview),
											 "file_selected",
											 G_CALLBACK(ui_comp_file_chooser_selected_cb),
											 "ring");	
			ui_comp_winmgr_register_window(UI_COMP_SKW_FILE_CHOOSER,
																		 filewindow);		
  	}						 
  	else
  	{
  		g_print("%s() ...............................\n",__FUNCTION__);
  		gchar *picpath = NULL;
  		fileview = ui_comp_skwindow_get_view (UI_COMP_SKWINDOW(filewindow));
  		picpath = g_build_filename(gem_env_get_resource_path(),
																 "sounds",
																  NULL,
																  NULL);
  		g_print("%s(): picpath = %s  \n",__FUNCTION__,picpath ? picpath : "null");
	  	gem_file_chooser_set_current_path(GEM_FILE_CHOOSER(fileview),picpath);
			g_signal_connect(G_OBJECT(filewindow),
											 "softkey_activated",
											 G_CALLBACK(ui_comp_file_chooser_softkey_activated_cb),
											 "ring");	
			g_signal_connect(G_OBJECT(fileview),
											 "file_selected",
											 G_CALLBACK(ui_comp_file_chooser_selected_cb),
											 "ring");	
  	}
													 							
		gtk_widget_show_all(filewindow); 	
  }  
  else if (nr == UI_COMP_SK_RIGHT)
  {
    g_print ("%s(): Right Softkey        nr = %d\n", __FUNCTION__,nr);
    if (view)
    {
      GEM_HASH_VIEW(view)->status = GEM_HV_STATUS_CANCEL;
    }
    ret = TRUE;
  }

  if (ret)
  {
//  	ui_comp_cnt_list_view_update(UI_COMP_CAT_LIST_VIEW(listview));
		gtk_widget_hide_all (GTK_WIDGET (window));			
	}

  return;
}

void action_cat_add_category_cb()
{
	GtkWidget *sub_window = NULL;
	GtkWidget *view = NULL;

	GtkWidget *catview = NULL;	
	catview = ui_comp_cat_edit_view_new(); 	
g_print("\n%s() : invoke the ui_comp_cont_edit_view_new()\n",__FUNCTION__);
	sub_window = ui_comp_skwindow_new(catview,
																		"Save",
																		"Cancel",															
																		"",
																		NULL,
																		0,
																		NULL);
	g_signal_connect(G_OBJECT(sub_window),
									 "softkey_activated",
									 G_CALLBACK(ui_comp_category_view_softkey_add_activated_cb),
									 NULL);					 
									 
	g_signal_connect(G_OBJECT(sub_window),
										"hide",
										G_CALLBACK(ui_comp_category_view_hide_cb),
										NULL);
	
	GemHashViewCell *cell = NULL;
	GtkWidget *entry = NULL;
	cell = gem_hash_view_get_item(GEM_HASH_VIEW(catview),CAT_PICTURE);		
	entry = gem_hash_view_cell_std_get_entry(GEM_HASH_VIEW_CELL_STD(cell));	
	g_print("%s(): sub_window = 0x%08x,entry = 0x%08x  cell=0x%08x \n",__FUNCTION__,(guint32)sub_window,(guint32)entry,(guint32)cell);
	 
	g_signal_connect(entry,
									"focus-in-event",
									G_CALLBACK(ui_comp_category_modify_pic_entry_in_cb),
									UI_COMP_SKWINDOW(sub_window));																		 
	g_signal_connect(entry,
									"focus-out-event",
									G_CALLBACK(ui_comp_category_modify_pic_entry_out_cb),
									UI_COMP_SKWINDOW(sub_window));						 
									
	cell = gem_hash_view_get_item(GEM_HASH_VIEW(catview),CAT_RINGTONE);		
	entry = gem_hash_view_cell_std_get_entry(GEM_HASH_VIEW_CELL_STD(cell));	
	g_print("%s(): sub_window = 0x%08x,entry = 0x%08x  cell=0x%08x \n",__FUNCTION__,(guint32)sub_window,(guint32)entry,(guint32)cell);
	 
	g_signal_connect(entry,
									"focus-in-event",
									G_CALLBACK(ui_comp_category_modify_ring_entry_in_cb),
									UI_COMP_SKWINDOW(sub_window));																		 
	g_signal_connect(entry,
									"focus-out-event",
									G_CALLBACK(ui_comp_category_modify_ring_entry_out_cb),
									UI_COMP_SKWINDOW(sub_window));											
									
	ui_comp_winmgr_register_window(UI_COMP_SKW_CAT_VIEW_EDIT,
																 sub_window);	
	gtk_widget_show_all(sub_window);
  return;
}

static void
ui_comp_category_view_softkey_modify_activated_cb (GpeSKWindow *window,
																									 gint nr,
																									 ab_category_t *category)
{
  gboolean ret = FALSE;
  const gchar *left_label = NULL;
  GtkWidget *view = NULL;  
  view = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(window));
  
  if (nr == UI_COMP_SK_LEFT && !picture_flag && !ringtone_flag)
  {
    g_print ("%s(): Left Softkey      \n", __FUNCTION__);

    if (view && gem_hash_view_get_editable (GEM_HASH_VIEW(view)))
    {    	
			GtkWidget *listwindow = NULL;

			listwindow = ui_comp_winmgr_get_window(UI_COMP_SKW_CAT_VIEW);
  		ab_enabler_cat_parse_from_edit_view (GEM_HASH_VIEW(view), &category);
    
      if (category)
      {
        gboolean update = FALSE;
        ab_uid_t uid = AB_ID_INVALID;        
        GtkWidget *window = NULL;    
  			window = ui_comp_winmgr_get_window (UI_COMP_SKW_CAT_VIEW);       
			  uid = (gint)action_get_current_contact_uid (UI_COMP_SKWINDOW(window));        
				
				if (uid != AB_ID_INVALID)
        {
        	update = TRUE;
        }
        if (update)
        {
      		ab_update_category(ab_enabler_get_session(0), category);     
        }
        GEM_HASH_VIEW(view)->status = GEM_HV_STATUS_SAVE;
      }
      ab_category_free (category);
    }
    ret = TRUE;
  }
  else if (nr == UI_COMP_SK_LEFT && picture_flag)
  {
  	GtkWidget *fileview = NULL;
  	GtkWidget *filewindow = NULL;  	
  	filewindow = ui_comp_winmgr_get_window(UI_COMP_SKW_FILE_CHOOSER);
  	if(filewindow == NULL)
  	{  	  	
  		fileview = gem_file_chooser_new();
  		gem_file_chooser_set_selectable(GEM_FILE_CHOOSER(fileview),FALSE);
  		gchar *picpath = NULL;
  		picpath = g_build_filename(gem_env_get_resource_path(),
																 "pixmaps",
																  NULL,
																  NULL);
  		g_print("%s(): picpath = %s  \n",__FUNCTION__,picpath ? picpath : "null");
	  	gem_file_chooser_set_current_path(GEM_FILE_CHOOSER(fileview),picpath);  		
			filewindow = ui_comp_skwindow_new(fileview,
																				"Ok",
																				"Cancel",															
																				"",
																				NULL,
																				0,
																				NULL);																	 
			g_signal_connect(G_OBJECT(filewindow),
											 "softkey_activated",
											 G_CALLBACK(ui_comp_file_chooser_softkey_activated_cb),
											 "pic");	
			g_signal_connect(G_OBJECT(fileview),
											 "file_selected",
											 G_CALLBACK(ui_comp_file_chooser_selected_cb),
											 "pic");													 
			ui_comp_winmgr_register_window(UI_COMP_SKW_FILE_CHOOSER,
																		 filewindow);		
  	}					
  	else
  	{
  		gchar *picpath = NULL;
  		fileview = ui_comp_skwindow_get_view (UI_COMP_SKWINDOW(filewindow));
  		picpath = g_build_filename(gem_env_get_resource_path(),
																 "pixmaps",
																  NULL,
																  NULL);
  		g_print("%s(): picpath = %s  \n",__FUNCTION__,picpath ? picpath : "null");
	  	gem_file_chooser_set_current_path(GEM_FILE_CHOOSER(fileview),picpath);
			g_signal_connect(G_OBJECT(filewindow),
											 "softkey_activated",
											 G_CALLBACK(ui_comp_file_chooser_softkey_activated_cb),
											 "pic");	
			g_signal_connect(G_OBJECT(fileview),
											 "file_selected",
											 G_CALLBACK(ui_comp_file_chooser_selected_cb),
											 "pic");			  	
  	}	 
													 							
		gtk_widget_show_all(filewindow); 	
  }    
  else if (nr == UI_COMP_SK_LEFT && ringtone_flag)    
  {
  	GtkWidget *fileview = NULL;
  	GtkWidget *filewindow = NULL;  	
  	filewindow = ui_comp_winmgr_get_window(UI_COMP_SKW_FILE_CHOOSER);
  
  	if(filewindow == NULL)
  	{  	  	
  		fileview = gem_file_chooser_new();
  		gem_file_chooser_set_selectable(GEM_FILE_CHOOSER(fileview),FALSE);
  		gchar *picpath = NULL;
  		picpath = g_build_filename(gem_env_get_resource_path(),
																 "sounds",
																  NULL,
																  NULL);
  		g_print("%s(): picpath = %s  \n",__FUNCTION__,picpath);
	  	gem_file_chooser_set_current_path(GEM_FILE_CHOOSER(fileview),picpath);  		
			filewindow = ui_comp_skwindow_new(fileview,
																				"Ok",
																				"Cancel",															
																				"",
																				NULL,
																				0,
																				NULL);																	 
			g_signal_connect(G_OBJECT(filewindow),
											 "softkey_activated",
											 G_CALLBACK(ui_comp_file_chooser_softkey_activated_cb),
											 "ring");	
			g_signal_connect(G_OBJECT(fileview),
											 "file_selected",
											 G_CALLBACK(ui_comp_file_chooser_selected_cb),
											 "ring");												 
											 
			ui_comp_winmgr_register_window(UI_COMP_SKW_FILE_CHOOSER,
																		 filewindow);		
  	}						 
  	else
  	{
  		g_print("%s() ...............................\n",__FUNCTION__);
  		gchar *picpath = NULL;
  		fileview = ui_comp_skwindow_get_view (UI_COMP_SKWINDOW(filewindow));
  		picpath = g_build_filename(gem_env_get_resource_path(),
																 "sounds",
																  NULL,
																  NULL);
  		g_print("%s(): picpath = %s  \n",__FUNCTION__,picpath ? picpath : "null");
	  	gem_file_chooser_set_current_path(GEM_FILE_CHOOSER(fileview),picpath);
			g_signal_connect(G_OBJECT(filewindow),
											 "softkey_activated",
											 G_CALLBACK(ui_comp_file_chooser_softkey_activated_cb),
											 "ring");	
			g_signal_connect(G_OBJECT(fileview),
											 "file_selected",
											 G_CALLBACK(ui_comp_file_chooser_selected_cb),
											 "ring");		  	
  	}
													 							
		gtk_widget_show_all(filewindow); 	
  }  
  else if (nr == UI_COMP_SK_RIGHT)
  {
    g_print ("%s(): Right Softkey        nr = %d\n", __FUNCTION__,nr);
    if (view)
    {
      GEM_HASH_VIEW(view)->status = GEM_HV_STATUS_CANCEL;
    }
    ret = TRUE;
  }
  if (ret)
  {
		gtk_widget_hide_all (window);
  }	
  return;
}

void action_cat_modify_category_cb()
{
	ab_category_t *category = NULL; 
  GtkWidget *window = NULL;
  GtkWidget *catlistview = NULL;
  GtkWidget *sub_window = NULL;
  GemHashViewCell *cell = NULL;
  GtkWidget *entry = NULL;
  ab_uid_t uid = AB_ID_INVALID;
  
  window = ui_comp_winmgr_get_window (UI_COMP_SKW_CAT_VIEW);
  uid = (ab_uid_t)action_get_current_contact_uid (UI_COMP_SKWINDOW(window));

  if (uid == AB_ID_INVALID)
  {
    return;
  }
	ab_get_category (ab_enabler_get_session(0), uid, &category);
    
  catlistview = ui_comp_cat_edit_view_new();     
  ab_category_print(category);
	
	gchar *fieldstr = NULL;
	
	fieldstr = g_strdup_printf("%d",uid);
	if(fieldstr!=NULL)
	{
		gem_hash_view_set_value(GEM_HASH_VIEW(catlistview),CAT_UID,fieldstr);
	}
	
	ab_category_get_name(category,&fieldstr);
	if(fieldstr!=NULL)
	{
		gem_hash_view_set_value(GEM_HASH_VIEW(catlistview),CAT_NAME,fieldstr);
	}
	
	ab_category_get_picture(category,&fieldstr);
	if(fieldstr!=NULL)
	{
		gem_hash_view_set_value(GEM_HASH_VIEW(catlistview),CAT_PICTURE,fieldstr);
	}
	
	ab_category_get_ringtone(category,&fieldstr);
	if(fieldstr!=NULL)
	{
		gem_hash_view_set_value(GEM_HASH_VIEW(catlistview),CAT_RINGTONE,fieldstr);
	}
	
	g_free(fieldstr);
	
	GEM_HASH_VIEW(catlistview)->focused_item = CAT_PICTURE;
	
	gem_hash_view_set_editable(GEM_HASH_VIEW(catlistview),TRUE);		
  sub_window = ui_comp_skwindow_new(catlistview,
																		"Save",
																		"Cancel",															
																		"",
																		NULL,
																		0,
																		NULL);
	g_signal_connect(G_OBJECT(sub_window),
								  "softkey_activated",
								   G_CALLBACK(ui_comp_category_view_softkey_modify_activated_cb),
							     category);
							    	
	g_signal_connect(G_OBJECT(sub_window),
									"hide",
									 G_CALLBACK(ui_comp_category_view_hide_cb),
									 NULL);
	cell = gem_hash_view_get_item(GEM_HASH_VIEW(catlistview),CAT_PICTURE);		
	entry = gem_hash_view_cell_std_get_entry(GEM_HASH_VIEW_CELL_STD(cell));		
 
	g_signal_connect(entry,
									"focus-in-event",
									 G_CALLBACK(ui_comp_category_modify_pic_entry_in_cb),
									 UI_COMP_SKWINDOW(sub_window));		
															 
	g_signal_connect(entry,
									"focus-out-event",
									G_CALLBACK(ui_comp_category_modify_pic_entry_out_cb),
									UI_COMP_SKWINDOW(sub_window));	
									
	cell = gem_hash_view_get_item(GEM_HASH_VIEW(catlistview),CAT_RINGTONE);		
	entry = gem_hash_view_cell_std_get_entry(GEM_HASH_VIEW_CELL_STD(cell));		
 
	g_signal_connect(entry,
									"focus-in-event",
									 G_CALLBACK(ui_comp_category_modify_ring_entry_in_cb),
									 UI_COMP_SKWINDOW(sub_window));		
															 
	g_signal_connect(entry,
									"focus-out-event",
									G_CALLBACK(ui_comp_category_modify_ring_entry_out_cb),
									UI_COMP_SKWINDOW(sub_window));										
									
  ui_comp_winmgr_register_window(UI_COMP_SKW_CAT_VIEW_EDIT,
															  sub_window);
	gtk_widget_show_all(sub_window);
	return;
}

void cat_delete_softkey_activated_cb(GpeSKWindow		*window,
																		 gint					 nr,
																		 gpointer			 user_data)
{
	g_print("%s(): entering......\n",
					__FUNCTION__);
	if (nr == UI_COMP_SK_LEFT)
	{
		ab_uid_t *uid = (ab_uid_t *)user_data;
		GtkWidget *listwindow = NULL;
		listwindow = ui_comp_winmgr_get_window (UI_COMP_SKW_CAT_VIEW);
		ab_remove_category(ab_enabler_get_session(0), (ab_uid_t)uid);
		 
		GtkWidget *ListWindow = NULL;
		GtkWidget *listview = NULL;
		 
		ListWindow = ui_comp_winmgr_get_window(UI_COMP_SKW_CAT_VIEW);
		listview =  ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(ListWindow)); 
		ab_enabler_ui_comp_list_view_delete(GEM_TREE_VIEW(listview), uid);
		
		ui_comp_cat_list_view_update(UI_COMP_CAT_LIST_VIEW(listview));
	}
	else if (nr == UI_COMP_SK_RIGHT)
	{		
	}
	
	gtk_widget_hide_all (GTK_WIDGET (window));
}

void action_cat_delete_category_cb()
{
	GtkWidget *dialog = NULL;
  ab_category_t *category = NULL; 
  GtkWidget *window = NULL;
  ab_uid_t uid = AB_ID_INVALID;
  window = ui_comp_winmgr_get_window (UI_COMP_SKW_CAT_VIEW);
  uid = (ab_uid_t)action_get_current_contact_uid (UI_COMP_SKWINDOW(window));
  
	g_print("%s(): uid = %d \n",__FUNCTION__,uid); 	   
	 	     
  if (uid == AB_ID_INVALID)
  {
    return;
  }
		
  ab_get_category (ab_enabler_get_session(0), uid, &category);
	ab_category_print(category);
	
	dialog = g_object_new(UI_COMP_TYPE_SKWINDOW, NULL);
	gem_sk_window_set_delete_warning (dialog, "Confirm to delete it? \n\n");
	gem_sk_dialog_set_position (window,dialog, 50);
	
	g_signal_connect(G_OBJECT(dialog),
									 "softkey_activated",
									 G_CALLBACK(cat_delete_softkey_activated_cb),
									 (gpointer) uid);
	gtk_widget_show_all(dialog);

  return;	
}

static gchar * uidesc = " \
	<ui>\
		<popup  action=\"PopupLeft\">\
			<menuitem name=\"add_cat\"			action=\"AddCat\"/>\
			<menuitem name=\"modify_cat\"			action=\"ModifyCat\"/>\
			<menuitem name=\"delete_cat\"			action=\"DeleteCat\"/>\
		</popup>\
	</ui>\
";

//		<menuitem name=\"list_cat\"			action=\"ListCat\"/>\

static GtkActionEntry actions[] = {
//	{"ListCat",			NULL, "_Detail",				"", "none",action_cat_list_category_cb },
  {"AddCat",			NULL, "_Add Category",				"", "none",action_cat_add_category_cb },
  {"ModifyCat",				NULL, "_Modify Category",		"", "none", action_cat_modify_category_cb},
  {"DeleteCat",				NULL, "_Delete Category",		"", "none", action_cat_delete_category_cb},
 	{"PopupLeft",		NULL, "Popup",				"", "none", NULL},
};

void ui_comp_category_skwindow_hide_cb()
{
	GtkWidget *cntlist_window = NULL;
	cntlist_window = ui_comp_winmgr_get_window(UI_COMP_SKW_CNT_VIEW);
	gpe_skwindow_set_softkey_label(GPE_SKWINDOW(cntlist_window),UI_COMP_SK_RIGHT,"Back");
}

GtkWidget *ui_comp_cat_window_new()
{
	GtkWidget *window = NULL;
	GtkWidget *catview = NULL;
	
	catview = ui_comp_cat_list_view_new(); 
  
  gpe_skwindow_set_menu_fullscreen(TRUE);
	window = ui_comp_skwindow_new(catview,
																"Options",
																"Back",															
																uidesc,
																actions,
																G_N_ELEMENTS(actions),
																"Categories");																
	g_print("%s():  catview = 0x%08x \n",__FUNCTION__,(guint32)catview);																	
	g_signal_connect(G_OBJECT(window),
									 "softkey_activated",
									 G_CALLBACK(softkey_activated_cb),
									 NULL);	
 	g_signal_connect(G_OBJECT(window),
									 "hide",
									 G_CALLBACK(ui_comp_category_skwindow_hide_cb),
									 NULL);	
	ui_comp_winmgr_register_window(UI_COMP_SKW_CAT_VIEW,
																 window);															 
	return window;
}                    

void action_cat_show_category_cb()
{
	GtkWidget *window = NULL;
	GtkWidget *view = NULL;
  
  window = ui_comp_winmgr_get_window(UI_COMP_SKW_CAT_VIEW);
  if(window == NULL)
  {
		window = ui_comp_cat_window_new();
	//		g_print("%s () :  window = 0x%08x  ............\n",__FUNCTION__,window);
		view = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(window));
		ab_enabler_cat_list_view_load_category(view);					
		ui_comp_winmgr_register_window(UI_COMP_SKW_CAT_VIEW,window);
		gem_tree_view_set_search_column(view,UI_COMP_CAT_LV_NAME,GTK_SORT_ASCENDING,NULL);
		ui_comp_cat_list_view_update(view);
		g_print("%s () :  view = 0x%08x  ............\n",__FUNCTION__,view);
  }
  else
  {
  	view = ui_comp_skwindow_get_view(UI_COMP_SKWINDOW(window));
		ui_comp_cat_list_view_update(view);
  }
  
	gtk_widget_show_all(window);	
}



/*
vi:ts=2:nowrap:ai:expandtab 
*/