/*	contact - LiPS Address Book Application
 *
 *	Authors: YE Nan <nan.ye@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#include <stdio.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gem.h>
#include <abtypes.h>
#include <abcategory.h>
#include <gemhashview.h>
#include <gemhashviewcellimg.h>
#include <uicompskwindow.h>
#include <uicompwinmgr.h>
#include <uicompcatlistview.h>
#include "enabler.h"

static void ui_comp_cat_list_view_class_init		(UICompCatListViewClass	*klass);
static void ui_comp_cat_list_view_init					(UICompCatListView			*catview);
static void	ui_comp_cat_list_view_destroy				(GtkObject							*object);

static GemTreeViewClass * parent_class = NULL;

static void 
cat_list_view_softkey_activated_cb (GpeSKWindow *window,
                                    gint nr,
                                    GemHashView  *view)
{
  gboolean ret = FALSE;	
  if (nr == UI_COMP_SK_LEFT)
  {
    g_print ("%s(): Left Softkey\n", __FUNCTION__);    
  }
  else if (nr == UI_COMP_SK_RIGHT)
  {
    g_print ("%s(): Right Softkey\n", __FUNCTION__);
    if (view)
    {
      view->status = GEM_HV_STATUS_CANCEL;
    }
    ret = TRUE;
  }
  if (ret)
  {
    gtk_widget_hide_all (GTK_WIDGET (window));
  }	
	return;	
}

//void
//mw_cat_list_view_row_cb(gchar *uid) 
//{
////	g_print("%s(): uidstr = %d entering ......\n",__FUNCTION__,uidstr);
//	ab_category_t *category = NULL;
////	ab_uid_t uid = AB_ID_INVALID;
//	g_print("%s() : uid = %d   ............        \n",__FUNCTION__,uid);
//  ab_get_category(ab_enabler_get_session(0), (ab_uid_t)uid, &category);
//  ab_category_print(category);
//  if (TRUE)
//  {
//    GtkWidget *catlistview = NULL;
//    GtkWidget *sub_window = NULL;
//    GtkWidget *app = NULL;
//		GtkWidget *cell = NULL;
//		GdkPixbuf *pixbuf = NULL;
//		gchar *picpath = NULL;
//		
//		ab_fid_t *fid = NULL;
//    gint i = 0;
//    ab_ftid_t ftid = 0;
//    
//    catlistview = ui_comp_cat_edit_view_new();     
//
//		gchar *fieldstr = NULL;
//		
//		fieldstr = g_strdup_printf("%d",uid);
//		if(fieldstr!=NULL)
//		{
//			gem_hash_view_set_value(GEM_HASH_VIEW(catlistview),CAT_UID,fieldstr);
//		}
//		
//		ab_category_get_name(category,&fieldstr);
//		if(fieldstr!=NULL)
//		{
//			gem_hash_view_set_value(GEM_HASH_VIEW(catlistview),CAT_NAME,fieldstr);
//		}
//		
//		ab_category_get_picture(category,&fieldstr);
//		if(fieldstr!=NULL)
//		{
//			gem_hash_view_set_value(GEM_HASH_VIEW(catlistview),CAT_PICTURE,fieldstr);
//		}
//		
//		ab_category_get_ringtone(category,&fieldstr);
//		if(fieldstr!=NULL)
//		{
//			gem_hash_view_set_value(GEM_HASH_VIEW(catlistview),CAT_RINGTONE,fieldstr);
//		}
//		g_free(fieldstr);
//       
//		gem_hash_view_set_editable(GEM_HASH_VIEW(catlistview),FALSE);
//    sub_window = ui_comp_skwindow_new(catlistview,
//																"",
//																"Back",															
//																"",
//																NULL,
//																0,
//																NULL);
//  	g_signal_connect(G_OBJECT(sub_window),
//									   "softkey_activated",
//									    G_CALLBACK(cat_list_view_softkey_activated_cb),
//								    	GEM_HASH_VIEW(catlistview));
//		ab_category_free (category);				    	
//
//		gtk_widget_show_all(sub_window);	
//  }
//
//  return;	
//}


static gboolean 
ui_comp_cat_list_view_row_activated(GtkTreeView *treeview, GtkTreePath *path,
                          			    GtkTreeViewColumn *col, gpointer user_data)
{
	action_cat_modify_category_cb();
//  GemTreeView *view = GEM_TREE_VIEW(user_data);
//  GtkTreeModel *model = NULL;
//  GtkTreeIter iter;
//
//
//	model = gem_tree_view_get_model(view);
//	
//  if (gtk_tree_model_get_iter (model, &iter, path))
//  {
//    gchar *uid = NULL;
//		
//    gtk_tree_model_get (model, &iter, UI_COMP_CAT_LV_UID, &uid, -1);
//				
//		mw_cat_list_view_row_cb(uid);            
//  //  g_free (uid);
//  }
//  return;
}

GType
ui_comp_cat_list_view_get_type (void)
{
	static GType cat_list_view_type = 0;

  if (!cat_list_view_type)
	{
		static const GTypeInfo cat_list_view_info =
		{
			sizeof (UICompCatListViewClass),
			NULL,		/* base_init */
			NULL,		/* base_finalize */
			(GClassInitFunc) ui_comp_cat_list_view_class_init,
			NULL,		/* class_finalize */
			NULL,		/* class_data */
			sizeof (UICompCatListView),
			0,			/* n_preallocs */
			(GInstanceInitFunc) ui_comp_cat_list_view_init,
			NULL,
		};

		cat_list_view_type = g_type_register_static(GEM_TYPE_TREE_VIEW,
																								"UICompCatListView",
																								&cat_list_view_info,
																								0);
	}

	return cat_list_view_type;
}

static void
ui_comp_cat_list_view_class_init (UICompCatListViewClass * klass)
{
  GtkObjectClass *object_class;
  object_class = (GtkObjectClass*)klass;
  parent_class = g_type_class_peek_parent(klass);
  object_class->destroy = ui_comp_cat_list_view_destroy;
	return;
}

static void
ui_comp_cat_list_view_destroy (GtkObject *object)
{
	UICompCatListView * cat_list_view = UI_COMP_CAT_LIST_VIEW(object);
  (*GTK_OBJECT_CLASS(parent_class)->destroy)(object);
  
  return;
}

void
ui_comp_cat_list_view_update (UICompCatListView	*catview)
{
	GtkTreePath *path = NULL;
	GtkTreeView *treeview = NULL;

  treeview = GTK_TREE_VIEW(gem_tree_view_get_view(GEM_TREE_VIEW(catview)));  
	path = gtk_tree_path_new_first();
	gtk_tree_view_set_cursor(treeview,
													 path,
													 NULL,
													 TRUE);
  gtk_tree_path_free(path);
	return;
}

static void
ui_comp_cat_list_view_init (UICompCatListView * catview)
{
	GtkWidget *treeview = NULL;
	GtkTreeViewColumn	*col = NULL;
	GtkCellRenderer *renderer = NULL;
	GtkListStore * liststore = NULL;
	
	g_print("%s(): invoke the gem_tree_get_view()\n",__FUNCTION__);
	treeview = gem_tree_view_get_view(GEM_TREE_VIEW(catview));
	/* column name */
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Name");
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);
	
	renderer = gtk_cell_renderer_text_new();
	gtk_cell_renderer_set_fixed_size(renderer,
																	 130,
																	 -1);
/*	g_object_set(G_OBJECT(renderer),
							 "xalign",
							 1.0,
							 NULL);
	g_object_set(G_OBJECT(renderer),
							 "ypad",
							 5,
							 NULL);
*/	
	gtk_tree_view_column_pack_start(col,
																	renderer,
																	TRUE);
	gtk_tree_view_column_set_alignment(col,
																		 1);
	gtk_tree_view_column_add_attribute(col,
																		 renderer,
																		 "text",
																		 UI_COMP_CAT_LV_NAME);
	/* column pic */
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Picutre");
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);
	
	renderer = gtk_cell_renderer_pixbuf_new();
	gtk_cell_renderer_set_fixed_size(renderer,
																	 32,
																	 32);
	gtk_tree_view_column_pack_start(col,
																	renderer,
																	TRUE);
	gtk_tree_view_column_add_attribute(col,
																		 renderer,
																		 "pixbuf",
																		 UI_COMP_CAT_LV_PIC);
	
	liststore = gtk_list_store_new(NUM_UI_COMP_CAT_LV_COLS,
																 G_TYPE_UINT,
																 G_TYPE_UINT,
																 G_TYPE_STRING,
																 GDK_TYPE_PIXBUF,
																 G_TYPE_INT);
	
	gem_tree_view_set_model(GEM_TREE_VIEW(catview),
													GTK_TREE_MODEL(liststore));													 
	g_object_unref(liststore);
	
	g_signal_connect (G_OBJECT ((GEM_TREE_VIEW(catview))->treeview), "row-activated",
                    G_CALLBACK (ui_comp_cat_list_view_row_activated), (gpointer) catview);	


	return;
}

GtkWidget *
ui_comp_cat_list_view_new (void)
{
	return gtk_widget_new(UI_COMP_TYPE_CAT_LIST_VIEW,
												NULL);
}



/*
vi:ts=2:nowrap:ai:expandtab 
*/
