/*	contact - LiPS Address Book Application
 *
 *	Authors: YE Nan <nan.ye@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */


#include <stdio.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gem.h>
#include <gdk/gdkkeysyms.h>
#include <uicompcnteditview.h>
#include <gemhashview.h>
#include <gemhashviewcellimg.h>
#include <abtemplate.h>
#include "enabler.h"
#include "gemhashviewcell.h"
#include "gemhashviewcellstd.h"


static void ui_comp_cnt_edit_view_class_init		(UICompCntEditViewClass	*klass);
static void ui_comp_cnt_edit_view_init					(UICompCntEditView			*cntview);
static void	ui_comp_cnt_edit_view_destroy				(GtkObject							*object);

static GemHashViewClass	*parent_class = NULL;


GType
ui_comp_cnt_edit_view_get_type(void)
{
	static GType cnt_edit_view_type = 0;
	
	g_print("%s(): cnt_edit_view_type: %d \n", __FUNCTION__, cnt_edit_view_type);

  if (!cnt_edit_view_type)
	{
		static const GTypeInfo cnt_edit_view_info =
		{
			sizeof (UICompCntEditViewClass),
			NULL,		/* base_init */
			NULL,		/* base_finalize */
			(GClassInitFunc) ui_comp_cnt_edit_view_class_init,
			NULL,		/* class_finalize */
			NULL,		/* class_data */
			sizeof (UICompCntEditView),
			0,			/* n_preallocs */
			(GInstanceInitFunc) ui_comp_cnt_edit_view_init,
			NULL,
		};

		cnt_edit_view_type = g_type_register_static(GEM_TYPE_HASH_VIEW,
																								"UICompCntEditView",
																								&cnt_edit_view_info,
																								0);
	}

	return cnt_edit_view_type;
}

static void
ui_comp_cnt_edit_view_class_init (UICompCntEditViewClass *klass)
{
  GtkObjectClass *object_class;
  object_class = (GtkObjectClass*)klass;
  parent_class = g_type_class_peek_parent(klass);
  object_class->destroy = ui_comp_cnt_edit_view_destroy;

	return;
}

static void
ui_comp_cnt_edit_view_destroy (GtkObject *object)
{
	UICompCntEditView *cnt_edit_view = UI_COMP_CNT_EDIT_VIEW(object);

  (*GTK_OBJECT_CLASS(parent_class)->destroy)(object);
  
  return;
}
static gboolean
ui_comp_cnt_edit_view_category_entry_key_press_cb (GtkWidget *widget,
                             	                  	 GdkEventKey *event,
                             	                   	 UICompCntEditView *view)
{

  if (event->keyval == GDK_Return)
  {
		action_add_to_category_cb();
  }

  if (event->keyval == GDK_Left ||
      event->keyval == GDK_Right ||
      event->keyval == GDK_Up || event->keyval == GDK_Down)
  {
    return FALSE;
  }

  return TRUE;
}

static void
ui_comp_cnt_edit_view_init (UICompCntEditView *cntview)
{
//	g_print("\n%s() : entering\n",__FUNCTION__);
//	GemHashView *base = GEM_HASH_VIEW(cntview);
//	GtkWidget *seperator = NULL;
//	GtkWidget *cell = NULL;
//	GtkWidget *image = NULL;
//	
//	//gchar *picpath = NULL;
//	GtkWidget *hbox = NULL;	
//	
//	/* Name Cell */
//	cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Name</span>");	 
//	gem_hash_view_set_item (GEM_HASH_VIEW(cntview),
//												  AB_IV_FULL_NAME,
//												  GEM_HASH_VIEW_CELL(cell));												 
//	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 100, -1);
//	
///* Image */
//  image = gtk_image_new ();
//  if (TRUE)
//  {  	
//    hbox = gtk_hbox_new (FALSE, 0);
//    gtk_widget_set_size_request (hbox, -1, 70);
//    gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 10);
//    gtk_box_pack_end (GTK_BOX (hbox), image,  FALSE, FALSE, 10);
//    gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 10);
//  }
//
//  /* Seperator */
//  seperator = gtk_hseparator_new ();
//  gtk_box_pack_start (GTK_BOX (base->layout), seperator, FALSE, FALSE, 0);
//
//  /* Mobile Number Cell */
//  cell = gem_hash_view_cell_std_new ("<span color=\"Blue\">Mobile Number</span>");
//  gem_hash_view_set_item (GEM_HASH_VIEW(cntview),
//                          AB_IV_MOBILE_NUM,
//                          GEM_HASH_VIEW_CELL (cell));	                                 
// 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                              (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);	
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);    
//  
//  /* Home Number */
//  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Home Number</span>");
//  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
//  											 AB_IV_HOME_NUM,
//  											 GEM_HASH_VIEW_CELL(cell)); 
//	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                              (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);  											  											 
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);   	
//	
//	/* Business Number */
//  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Business Number</span>");
//  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
//  											 AB_IV_BUSINESS_NUM,
//  											 GEM_HASH_VIEW_CELL(cell));
// 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);  		
//	
//	/* FAX Number */
//  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Fax Number</span>");
//  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
//  									     AB_IV_FAX_NUM,
//  											 GEM_HASH_VIEW_CELL(cell));
//	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);  
//	
//	/* Company */
//  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Company</span>");
//  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
//  											 AB_IV_COMPANY,
//  											 GEM_HASH_VIEW_CELL(cell));
// 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0); 
//	
//	/* Department */
//  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Department</span>");
//  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
//  											 AB_IV_DEPARTMENT,
//  											 GEM_HASH_VIEW_CELL(cell));
// 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);
//  
//  /* Website */
//  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Website</span>");
//  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
//  											 AB_IV_WEBSITE,
//  											 GEM_HASH_VIEW_CELL(cell));
// 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0); 
//  
//  /* Email */
//  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Email</span>");
//  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
//  											 AB_IV_EMAIL,
//  											 GEM_HASH_VIEW_CELL(cell));
// 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0); 
//
//	/* Image Cell */
//  cell = gem_hash_view_cell_image_new ("<span color=\"Blue\">Picture</span>");
//  
//  gem_hash_view_cell_set_visible (GEM_HASH_VIEW_CELL(cell),
// 		    												  TRUE);
//  gem_hash_view_cell_image_set_buddy (GEM_HASH_VIEW_CELL_IMAGE (cell), image);  
// 
//  gem_hash_view_cell_set_value (GEM_HASH_VIEW_CELL_IMAGE (cell), "icon01.png");
//  gem_hash_view_set_item (GEM_HASH_VIEW (cntview),
//                          AB_IV_PICTURE,
//                          GEM_HASH_VIEW_CELL (cell));
//	                   
// 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);  
//   
//  /* Ringtone */
//  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Ringtone</span>");
//  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
//  											 AB_IV_RINGTONE,
//  											 GEM_HASH_VIEW_CELL(cell));
// 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0); 
//  
//  /* Home Address */
//  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Home Address</span>");
//  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
//  											 AB_IV_HOME_STREET,
//  											 GEM_HASH_VIEW_CELL(cell));
// 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0); 
//  
//  /* Business Address */
//  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Business Address</span>");
//  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
//  											 AB_IV_BUSI_STREET,
//  											 GEM_HASH_VIEW_CELL(cell));
// 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);
//  
//  /* Category */
//  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Category</span>");
//  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
//  											 AB_IV_CATEGORY_ID,
//  											 GEM_HASH_VIEW_CELL(cell));
// 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 180, -1);
// 
////  g_signal_connect (G_OBJECT (view->cat_entry), "focus-in-event",
////                      G_CALLBACK (entry_focus_in_cb), (gpointer) view);
////    g_signal_connect (G_OBJECT (view->cat_entry), "focus-out-event",
////                      G_CALLBACK (entry_focus_out_cb), (gpointer) view);
//  g_signal_connect (G_OBJECT (GEM_HASH_VIEW_CELL_STD(cell)->entry), "key-press-event",
//                    G_CALLBACK
//                    (ui_comp_cnt_edit_view_category_entry_key_press_cb),
//                    (gpointer) cntview);
//  image = gtk_image_new ();
//   if (TRUE)
//  {
//    GdkPixbuf *pixbuf = NULL;
//    gchar *picpath = NULL;
//    picpath = g_build_filename (gem_env_get_resource_path(),
//															  "pixmaps",
//													  	   "categories.png",
//															   NULL);
//		gem_resource_load_pic(picpath,
//													GEM_PIC_SMALL);
//		pixbuf = gem_resource_find_pic(picpath,
//																	 GEM_PIC_SMALL);
//    gtk_image_set_from_pixbuf (GTK_IMAGE (image), pixbuf);
//    
//    g_free (picpath);
//  }
//  if (TRUE)
//  {  	
//    hbox = gtk_hbox_new (FALSE, 0);
//    gtk_widget_set_size_request (hbox, -1, -1);
//    gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//    gtk_box_pack_start (GTK_BOX (hbox), image, FALSE, FALSE, 0);
//    gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 10);
//  }
//  
//  /*UID*/
//	cell = gem_hash_view_cell_std_new("<span color=\"Blue\">UID</span>");	 
//	gem_hash_view_set_item (GEM_HASH_VIEW(cntview),
//												  AB_IV_UID,
//												  GEM_HASH_VIEW_CELL(cell));		
//	gem_hash_view_cell_set_visible(GEM_HASH_VIEW_CELL(cell),FALSE);																				 
// 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
//                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
//	hbox = gtk_hbox_new (FALSE, 0);
//  gtk_widget_set_size_request (hbox, -1, -1);
//  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
//  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0); 
//    
//  GEM_HASH_VIEW(cntview)->focused_item = AB_IV_FULL_NAME;
//
//	return;
}

GtkWidget *
ui_comp_cnt_edit_view_new (void)
{
	return gtk_widget_new(UI_COMP_TYPE_CNT_EDIT_VIEW,
												NULL);
}
ui_comp_cnt_edit_view_constructor(ab_contact_t *contact,UICompCntEditView *cntview)
{
	GemHashView *base = GEM_HASH_VIEW(cntview);
	GtkWidget *seperator = NULL;
	GtkWidget *cell = NULL;
	GtkWidget *image = NULL;
	
	GtkWidget *hbox = NULL;	
	
	/* Name Cell */
	cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Name</span>");	 
	gem_hash_view_set_item (GEM_HASH_VIEW(cntview),
												  AB_IV_FULL_NAME*1000,
												  GEM_HASH_VIEW_CELL(cell));												 
	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
                               (GEM_HASH_VIEW_CELL_STD(cell)), 100, -1);
	
/* Image */
  image = gtk_image_new ();
  if (TRUE)
  {  	
    hbox = gtk_hbox_new (FALSE, 0);
    gtk_widget_set_size_request (hbox, -1, 70);
    gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 10);
    gtk_box_pack_end (GTK_BOX (hbox), image,  FALSE, FALSE, 10);
    gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 10);
  }

  /* Seperator */
  seperator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (base->layout), seperator, FALSE, FALSE, 0);
  
	if(contact==NULL)
	{ 
		g_print("\n%s() : entering\n",__FUNCTION__);

	
	  /* Mobile Number Cell */
	  cell = gem_hash_view_cell_std_new ("<span color=\"Blue\">Mobile Number</span>");
	  gem_hash_view_set_item (GEM_HASH_VIEW(cntview),
	                          AB_IV_MOBILE_NUM*1000,
	                          GEM_HASH_VIEW_CELL (cell));	                                 
	 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                              (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);	
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);    
	  
	  /* Home Number */
	  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Home Number</span>");
	  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
	  											 AB_IV_HOME_NUM*1000,
	  											 GEM_HASH_VIEW_CELL(cell)); 
		gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                              (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);  											  											 
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);   	
		
		/* Business Number */
	  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Business Number</span>");
	  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
	  											 AB_IV_BUSINESS_NUM*1000,
	  											 GEM_HASH_VIEW_CELL(cell));
	 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);  		
		
		/* FAX Number */
	  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Fax Number</span>");
	  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
	  									     AB_IV_FAX_NUM*1000,
	  											 GEM_HASH_VIEW_CELL(cell));
		gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);  
		
		/* Company */
	  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Company</span>");
	  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
	  											 AB_IV_COMPANY*1000,
	  											 GEM_HASH_VIEW_CELL(cell));
	 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0); 
		
		/* Department */
	  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Department</span>");
	  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
	  											 AB_IV_DEPARTMENT*1000,
	  											 GEM_HASH_VIEW_CELL(cell));
	 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);
	  
	  /* Website */
	  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Website</span>");
	  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
	  											 AB_IV_WEBSITE*1000,
	  											 GEM_HASH_VIEW_CELL(cell));
	 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0); 
	  
	  /* Email */
	  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Email</span>");
	  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
	  											 AB_IV_EMAIL*1000,
	  											 GEM_HASH_VIEW_CELL(cell));
	 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0); 
	
		/* Image Cell */
	  cell = gem_hash_view_cell_image_new ("<span color=\"Blue\">Picture</span>");
	  
	  gem_hash_view_cell_set_visible (GEM_HASH_VIEW_CELL(cell),
	 		    												  TRUE);
	  gem_hash_view_cell_image_set_buddy (GEM_HASH_VIEW_CELL_IMAGE (cell), image);  
	 
	  gem_hash_view_cell_set_value (GEM_HASH_VIEW_CELL_IMAGE (cell), "icon01.png");
	  gem_hash_view_set_item (GEM_HASH_VIEW (cntview),
	                          AB_IV_PICTURE*1000,
	                          GEM_HASH_VIEW_CELL (cell));
		                   
	 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);  
	   
	  /* Ringtone */
	  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Ringtone</span>");
	  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
	  											 AB_IV_RINGTONE*1000,
	  											 GEM_HASH_VIEW_CELL(cell));
	 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0); 
	  
	  /* Home Address */
	  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Home Address</span>");
	  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
	  											 AB_IV_HOME_STREET*1000,
	  											 GEM_HASH_VIEW_CELL(cell));
	 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0); 
	  
	  /* Business Address */
	  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Business Address</span>");
	  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
	  											 AB_IV_BUSI_STREET*1000,
	  											 GEM_HASH_VIEW_CELL(cell));
	 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);
	  
	 
	}
	else
	{
		gint i = 0;
	  ab_fid_t *fid = NULL;
		ab_contact_list_fields(contact,&fid); 
		for (i = 2; fid[i] != NULL; i++)
		{
			if(fid[i] == AB_IV_PICTURE*1000)
			{
				/* Image Cell */
			  cell = gem_hash_view_cell_image_new ("<span color=\"Blue\">Picture</span>");
			  
			  gem_hash_view_cell_set_visible (GEM_HASH_VIEW_CELL(cell),
			 		    												  TRUE);
			  gem_hash_view_cell_image_set_buddy (GEM_HASH_VIEW_CELL_IMAGE (cell), image);  
			 
			  gem_hash_view_cell_set_value (GEM_HASH_VIEW_CELL_IMAGE (cell), "icon01.png");
			  gem_hash_view_set_item (GEM_HASH_VIEW (cntview),
			                          AB_IV_PICTURE*1000,
			                          GEM_HASH_VIEW_CELL (cell));
				                   
			 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
			                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
				hbox = gtk_hbox_new (FALSE, 0);
			  gtk_widget_set_size_request (hbox, -1, -1);
			  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
			  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);
			}
			else if (fid[i] == AB_IV_RINGTONE*1000)
			{
				/* Ringtone */
			  cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Ringtone</span>");
			  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
			  											 AB_IV_RINGTONE*1000,
			  											 GEM_HASH_VIEW_CELL(cell));
			 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
			                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
				hbox = gtk_hbox_new (FALSE, 0);
			  gtk_widget_set_size_request (hbox, -1, -1);
			  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
			  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);
			}
			else
			{
		    ab_ftid_t ftid = 0;
		   	gchar *label = NULL;
		   	gchar *name =NULL;
				ab_contact_get_field_label (contact,fid[i],&label);
				name = g_strdup_printf("%s%s%s","<span color=\"Blue\">",label,"</span>");
			 	cell = gem_hash_view_cell_std_new (name);
			  gem_hash_view_set_item (GEM_HASH_VIEW(cntview),
			                          fid[i],
			                          GEM_HASH_VIEW_CELL (cell));
			 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
			                              (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);	
				hbox = gtk_hbox_new (FALSE, 0);
			  gtk_widget_set_size_request (hbox, -1, -1);
			  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
			  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0);
			  free(name);
			  free(label);
			}  
		}
		 /* Category */
	  
	}
		cell = gem_hash_view_cell_std_new("<span color=\"Blue\">Category</span>");
	  gem_hash_view_set_item(GEM_HASH_VIEW(cntview),
	  											 AB_IV_CATEGORY_ID*1000,
	  											 GEM_HASH_VIEW_CELL(cell));
	 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                               (GEM_HASH_VIEW_CELL_STD(cell)), 180, -1);
	  g_signal_connect (G_OBJECT (GEM_HASH_VIEW_CELL_STD(cell)->entry), "key-press-event",
	                    G_CALLBACK
	                    (ui_comp_cnt_edit_view_category_entry_key_press_cb),
	                    (gpointer) cntview);
	  image = gtk_image_new ();
	  if (TRUE)
	  {
	    GdkPixbuf *pixbuf = NULL;
	    gchar *picpath = NULL;
	    picpath = g_build_filename (gem_env_get_resource_path(),
																  "pixmaps",
														  	   "categories.png",
																   NULL);
			gem_resource_load_pic(picpath,
														GEM_PIC_SMALL);
			pixbuf = gem_resource_find_pic(picpath,
																		 GEM_PIC_SMALL);
	    gtk_image_set_from_pixbuf (GTK_IMAGE (image), pixbuf);
	    
	    g_free (picpath);
	  }
	  if (TRUE)
	  {  	
	    hbox = gtk_hbox_new (FALSE, 0);
	    gtk_widget_set_size_request (hbox, -1, -1);
	    gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	    gtk_box_pack_start (GTK_BOX (hbox), image, FALSE, FALSE, 0);
	    gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 10);
	  }
	  
	  /*UID*/
		cell = gem_hash_view_cell_std_new("<span color=\"Blue\">UID</span>");	 
		gem_hash_view_set_item (GEM_HASH_VIEW(cntview),
													  AB_IV_UID*1000,
													  GEM_HASH_VIEW_CELL(cell));		
		gem_hash_view_cell_set_visible(GEM_HASH_VIEW_CELL(cell),FALSE);																				 
	 	gtk_widget_set_size_request (gem_hash_view_cell_std_get_entry
	                               (GEM_HASH_VIEW_CELL_STD(cell)), 215, -1);
		hbox = gtk_hbox_new (FALSE, 0);
	  gtk_widget_set_size_request (hbox, -1, -1);
	  gtk_box_pack_start (GTK_BOX (hbox), cell, FALSE, FALSE, 0);
	  gtk_box_pack_start (GTK_BOX (base->layout), hbox,  FALSE, FALSE, 0); 
	    
	  GEM_HASH_VIEW(cntview)->focused_item = AB_IV_FULL_NAME*1000;
	  
	return;
}

/*
vi:ts=2:nowrap:ai:expandtab 
*/



