/*	contact - LiPS Address Book Application
 *
 *	Authors: YE Nan <nan.ye@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */


#include <stdio.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gem.h>
#include <gdk/gdkkeysyms.h>
#include <uicompmemstatusview.h>
#include <gemhashview.h>
#include <gemhashviewcellimg.h>
#include <abtemplate.h>
#include "enabler.h"
#include "gemhashviewcell.h"
#include "gemhashviewcellstd.h"

#define UI_COMP_MEM_STATUS_VIEW_GET_PRIVATE(obj)(G_TYPE_INSTANCE_GET_PRIVATE((obj), \
																								 UI_COMP_TYPE_MEM_STATUS_VIEW, \
																								 UICompMemCheckViewPriv));
																								 
static void ui_comp_mem_status_view_class_init		(UICompMemCheckViewClass	*klass);
static void ui_comp_mem_status_view_init					(UICompMemCheckView			*memstatus);
static void	ui_comp_mem_status_view_destroy				(GtkObject							*object);

static GemHashViewClass	*parent_class = NULL;

typedef struct _UICompMemCheckViewPriv UICompMemCheckViewPriv;

struct _UICompMemCheckViewPriv
{
	GtkWidget 		*progressbar_local;
	GtkWidget 		*progressbar_sim;
	GtkWidget 		*label_local;
	GtkWidget			*label_sim;
};


GType
ui_comp_mem_status_view_get_type(void)
{
	static GType mem_status_view_type = 0;
	

  if (!mem_status_view_type)
	{
		static const GTypeInfo mem_status_view_info =
		{
			sizeof (UICompMemCheckViewClass),
			NULL,		/* base_init */
			NULL,		/* base_finalize */
			(GClassInitFunc) ui_comp_mem_status_view_class_init,
			NULL,		/* class_finalize */
			NULL,		/* class_data */
			sizeof (UICompMemCheckView),
			0,			/* n_preallocs */
			(GInstanceInitFunc) ui_comp_mem_status_view_init,
			NULL,
		};

		mem_status_view_type = g_type_register_static(GEM_TYPE_HASH_VIEW,
																									"UICompMemCheckView",
																									&mem_status_view_info,
																									0);
	}

	return mem_status_view_type;
}

static void
ui_comp_mem_status_view_class_init (UICompMemCheckViewClass *klass)
{
  GtkObjectClass *object_class;
  object_class = (GtkObjectClass*)klass;
  parent_class = g_type_class_peek_parent(klass);
	g_type_class_add_private(klass,
													 sizeof(UICompMemCheckViewPriv));
  object_class->destroy = ui_comp_mem_status_view_destroy;

	return;
}

static void
ui_comp_mem_status_view_destroy (GtkObject *object)
{
	UICompMemCheckView *mem_status_view = UI_COMP_MEM_STATUS_VIEW(object);

  (*GTK_OBJECT_CLASS(parent_class)->destroy)(object);
  
  return;
}


static void
ui_comp_mem_status_view_init(UICompMemCheckView			*memstatus)
{
	UICompMemCheckViewPriv *priv = UI_COMP_MEM_STATUS_VIEW_GET_PRIVATE(memstatus);
	
	g_print("\n%s() : entering\n",__FUNCTION__);
	GemHashView *base = GEM_HASH_VIEW(memstatus);
	GtkWidget *image = NULL;
	GtkWidget *seperator = NULL;
	GtkWidget *cell = NULL;
	GtkWidget *vbox = NULL;	
	GtkWidget *hbox = NULL;	
	GtkWidget *hbox_tmp = NULL;
	GtkWidget *label = NULL;
	GtkWidget *label_local1 = NULL;
	GtkWidget *label_local2 = NULL;
	GtkWidget *label_sim1 = NULL;
	GtkWidget *label_sim2 = NULL;
  GtkWidget *pro_bar_local = NULL;
  GtkWidget *pro_bar_sim = NULL;
  GdkPixbuf *pixbuf = NULL;
  gchar *picpath = NULL;
	GdkColor color;
  gdk_color_parse ("Blue", &color);
	PangoFontDescription *font_desc = pango_font_description_from_string ("Sans 12");
  pro_bar_local= gtk_progress_bar_new();
  pro_bar_sim = gtk_progress_bar_new();
	
	hbox = gtk_hbox_new(FALSE,0);
	vbox = gtk_vbox_new(FALSE,0);
	hbox_tmp = gtk_hbox_new(FALSE,0);
	gtk_widget_set_size_request (hbox_tmp, -1, 30);
	label = gtk_label_new("");
	gtk_widget_modify_fg (label_local1, GTK_STATE_NORMAL, &color);
	gtk_box_pack_start(GTK_BOX(hbox_tmp),label,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox_tmp,FALSE,FALSE,0);

	hbox_tmp = gtk_hbox_new(FALSE,0);
	label = gtk_label_new("");
	gtk_widget_modify_fg (label_local1, GTK_STATE_NORMAL, &color);
	gtk_box_pack_start(GTK_BOX(hbox_tmp),label,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox_tmp,FALSE,FALSE,0);
	
  image = gtk_image_new ();
  picpath = g_build_filename (gem_env_get_resource_path(),
														  "pixmaps",
												  	   "categories.png",
														   NULL);
	gem_resource_load_pic(picpath,
												GEM_PIC_SMALL);
	pixbuf = gem_resource_find_pic(picpath,
																 GEM_PIC_SMALL);
  gtk_image_set_from_pixbuf (GTK_IMAGE (image), pixbuf);
  
  g_free (picpath);
	hbox_tmp = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox_tmp),image,FALSE,FALSE,0);	
	gtk_box_pack_start(GTK_BOX(vbox),hbox_tmp,FALSE,FALSE,0);
	
	hbox_tmp = gtk_hbox_new(FALSE,0);
	label = gtk_label_new("");
	gtk_widget_modify_fg (label_local1, GTK_STATE_NORMAL, &color);
	gtk_box_pack_start(GTK_BOX(hbox_tmp),label,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox_tmp,FALSE,FALSE,0);
	
	hbox_tmp = gtk_hbox_new(FALSE,0);
	label = gtk_label_new("");
	gtk_widget_modify_fg (label_local1, GTK_STATE_NORMAL, &color);
	gtk_box_pack_start(GTK_BOX(hbox_tmp),label,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox_tmp,FALSE,FALSE,0);

	image = gtk_image_new ();
  picpath = g_build_filename (gem_env_get_resource_path(),
														  "pixmaps",
												  	   "iconsim.png",
														   NULL);
	gem_resource_load_pic(picpath,
												GEM_PIC_SMALL);
	pixbuf = gem_resource_find_pic(picpath,
																 GEM_PIC_SMALL);
  gtk_image_set_from_pixbuf (GTK_IMAGE (image), pixbuf);
  
  g_free (picpath);
	hbox_tmp = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox_tmp),image,FALSE,FALSE,0);	
	gtk_box_pack_start(GTK_BOX(vbox),hbox_tmp,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox),vbox,FALSE,FALSE,10);
	
	
	vbox = gtk_vbox_new(FALSE,0);
	label = gtk_label_new("");
	hbox_tmp = gtk_hbox_new(FALSE,0);
	gtk_widget_set_size_request (hbox_tmp, -1, 30);
	gtk_box_pack_start(GTK_BOX(hbox_tmp),label,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox_tmp,FALSE,FALSE,0);	
	
	hbox_tmp = gtk_hbox_new(FALSE,0);
	label_local1 = gtk_label_new("Local");
  gtk_widget_modify_fg (label_local1, GTK_STATE_NORMAL, &color);
	label_local2 = gtk_label_new("1000/2000");
	gtk_widget_modify_fg (label_local2, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_font (label_local2, font_desc);
  gtk_widget_modify_font (label_local1, font_desc);

	gtk_box_pack_start(GTK_BOX(hbox_tmp),label_local1,FALSE,FALSE,0);
	gtk_box_pack_end(GTK_BOX(hbox_tmp),label_local2,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox_tmp,FALSE,FALSE,0);
	
	hbox_tmp = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox_tmp),pro_bar_local,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox_tmp,FALSE,FALSE,0);
	
	label = gtk_label_new("");
	hbox_tmp = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox_tmp),label,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox_tmp,FALSE,FALSE,0);
	
	hbox_tmp = gtk_hbox_new(FALSE,0);
	label_sim1 = gtk_label_new("SIM");
  gtk_widget_modify_fg (label_sim1, GTK_STATE_NORMAL, &color);
	label_sim2 = gtk_label_new("1400/2000");
 	gtk_widget_modify_fg (label_sim2, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_font (label_sim1, font_desc);
  gtk_widget_modify_font (label_sim2, font_desc);
  
	gtk_box_pack_start(GTK_BOX(hbox_tmp),label_sim1,FALSE,FALSE,0);
	gtk_box_pack_end(GTK_BOX(hbox_tmp),label_sim2,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox_tmp,FALSE,FALSE,0);
	
	hbox_tmp = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox_tmp),pro_bar_sim,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox_tmp,FALSE,FALSE,0);
	
	gtk_box_pack_start(GTK_BOX(hbox),vbox,FALSE,FALSE,0);
	
	vbox = gtk_vbox_new(FALSE,0);
	label = gtk_label_new("");
	gtk_box_pack_start(GTK_BOX(hbox),label,TRUE,TRUE,0);
	
	gtk_box_pack_start(GTK_BOX(base->layout),hbox,FALSE,FALSE,0);
	
	gtk_box_pack_start(GTK_BOX(base->layout),hbox,FALSE,FALSE,0);
	
  
  if(pro_bar_local)
  	priv->progressbar_local = pro_bar_local;
  if(pro_bar_sim)
  	priv->progressbar_sim = pro_bar_sim;
  if(label_local2)
  	priv->label_local = label_local2;
  if(label_sim2)
  	priv->label_sim = label_sim2;

  pango_font_description_free (font_desc);
	return;
}

GtkWidget *
ui_comp_mem_status_view_new (void)
{
	return gtk_widget_new(UI_COMP_TYPE_MEM_STATUS_VIEW,
												NULL);
}

void
ui_comp_mem_status_progress_set_local(UICompMemCheckView *memstatus, gint use, gint unuse)
{
	UICompMemCheckViewPriv *priv = UI_COMP_MEM_STATUS_VIEW_GET_PRIVATE(memstatus);
	gchar *percent = g_strdup_printf("%d/%d",use,unuse);
	gtk_label_set_label(GTK_LABEL(priv->label_local),percent);
	gtk_progress_bar_set_fraction(priv->progressbar_local,(gdouble)use/(gdouble)unuse);	
}

void
ui_comp_mem_status_progress_set_sim(UICompMemCheckView *memstatus, gint use, gint unuse)
{
	UICompMemCheckViewPriv *priv = UI_COMP_MEM_STATUS_VIEW_GET_PRIVATE(memstatus);
	gchar *percent = g_strdup_printf("%d/%d",use,unuse);
	gtk_label_set_label(priv->label_sim,percent);
	gtk_progress_bar_set_fraction(priv->progressbar_sim,(gdouble)use/(gdouble)unuse);	
}


/*
vi:ts=2:nowrap:ai:expandtab 
*/



